// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "embeddedgps.h"
#include "ChildView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// 
/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
//	m_uX=0;m_uY=0;
//	m_fZoom = 1.0;
	m_xMove=0;
	m_yMove=0;
	m_mapCurrent=NULL;
	m_RedPen.CreatePen(PS_SOLID,2,RGB(255,0,0));
	m_DrawPen.CreatePen(PS_SOLID,1,RGB(0,0,0));

}

CChildView::~CChildView()
{
	m_RedPen.DeleteObject();
	m_DrawPen.DeleteObject();
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
void CChildView::OnPaint() 
{
CGpsFrame *dat = &theApp.m_GpsData;
	CPaintDC dc(this); // device context for painting

CString str;
	str.Format(_T("%02d-%02d-%4d"),dat->day,dat->month,dat->year);
	dc.SetTextColor((dat->FillFlags & GFF_DATE)?RGB(0,0,0):RGB(128,128,128));
	dc.DrawText(str,CRect(6,1,20,20),DT_NOCLIP );
	CRect r;
	GetClientRect(&r);	



//	str.Format(_T("Hello there the time is: %d:%02d:%02d "),dat->hour,dat->min,dat->second);
//	dc->DrawText(str,CRect(12,12,20,20),DT_NOCLIP );
	switch(theApp.m_iViewType)
	{
	case 1:	ShowData(&dc,dat);	break;
	case 2:	ShowCompass(&dc,dat); break;
	case 3:	ShowTrack(&dc,dat); break;
	case 4:	ShowSat(&dc,dat); break;
	case 5:	if(m_mapCurrent!=NULL)
				{
					ShowMap(&dc,dat); break;
				}
	default:theApp.m_iViewType=1; Invalidate();
	}
//	if(theApp.m_iViewType!=5)
//	{
			
	str.Format(_T("Pnt:%d Sec:%2d Sats:%d Dltn:%.1f Zm:%.1f %s"),theApp.m_lstPoints.GetCount(),dat->m_SecCounter,dat->SatCnt,dat->Dilution,m_mapCurrent!=NULL?m_mapCurrent->m_dZoom:0.0,
			(dat->RmcStatus&&dat->GgaStatus)?_T("OK      "):_T("No signal"));	// time since last store
		dc.SetTextColor(RGB(0,0,0));
		dc.DrawText(str,CRect(6,r.bottom-14,20,20),DT_NOCLIP );
//	}
	// Do not call CWnd::OnPaint() for painting messages
}

#define COL_NOSIGNAL	RGB(255,0,0)
#define COL_WEAKSIGNAL	RGB(128,128,128)
/////////////////////////////////////////////////////////////////////////////
void CChildView::ShowData(CPaintDC *dc,CGpsFrame *dat)
{
CString str;
				float d,m,s;
	CRect r;
	GetClientRect(&r);	
	int id,im,is;

	HGDIOBJ old = dc->SelectObject(theApp.m_fntLargeFont);


	str.Format(_T("%2d:%02d:%02d"),dat->hour,dat->min,dat->second);
RECT rect;
	rect.left=rect.top=0;
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->SetTextColor((dat->FillFlags & GFF_TIME)?RGB(0,0,0):COL_NOSIGNAL);
	dc->DrawText(str,CRect(r.right-(rect.right-rect.left),1,r.right,r.top+1+(rect.bottom-rect.top)),DT_NOCLIP );
	int y=rect.bottom-rect.top; y+=2;

	dc->SelectObject(theApp.m_fntMediumFont);

	str="W";
	dc->DrawText(str,&rect,DT_CALCRECT );
	int right = r.right-(rect.right-rect.left);

	str=dat->Latitude<0?'S':'N';
	dc->SetTextColor((dat->FillFlags & GFF_LONGITUDE)?RGB(0,0,0):COL_NOSIGNAL);
	dc->DrawText(str,CRect(right,y,r.right,y+(rect.bottom-rect.top)),DT_NOCLIP );

				d = dat->Latitude;
				if(d<0) d=-d;
				m=d-(int)d;
				m*=60.0;
				s=m-(int)m;
				s*=60.0;

		//		str.Format(_T("%.0f%.0f'%.1f''%c"),d-0.5,m-0.5,s,dat->Latitude<0?'S':'N');
//				str.Format(_T("%.0f%.3f'%c"),d-0.5,m,dat->Latitude<0?'S':'N');
			//	d = dat->Latitude;
				id= (int)d;//(d<0?-d:d);
				im= (d-id)*60.0;
			//	is= (d-(id)/60.0;
				str.Format(_T("%4d%2d'%4.1f''"),id,im,s); //%c",dat->Latitude<0?'S':'N');

		//		if( (dat->FillFlags & (GFF_LATITUDE|GFF_LONGITUDE)) == (GFF_LATITUDE|GFF_LONGITUDE) )

	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(right-(rect.right-rect.left),y,right,y+(rect.bottom-rect.top)),DT_NOCLIP );
	y+=(rect.bottom-rect.top);
	y++;

	str = dat->Longitude<0?'W':'E';
	dc->SetTextColor((dat->FillFlags & GFF_LATITUDE)?RGB(0,0,0):COL_NOSIGNAL);
	dc->DrawText(str,CRect(right,y,r.right,y+(rect.bottom-rect.top)),DT_NOCLIP );
	//	m_strLat2.Format(_T("%c"),dat->Latitude<0?'S':'N');
				d = dat->Longitude;
				if(d<0) d=-d;
				m=d-(int)d;
				m*=60.0;
				s=m-(int)m;
				s*=60.0;
			//	str.Format(_T("%.0f%.3f'%c"),d-0.5,m,dat->Longitude<0?'W':'E');
			//	m_strLong2.Format(_T("%c"),dat->Longitude<0?'E':'W');
				id= (int)d;//(d<0?-d:d);
				im= (d-id)*60.0;
			//	is= (d-(id)/60.0;
				str.Format(_T("%4d%2d'%4.1f''"),id,im,s); //%c,dat->Longitude<0?'W':'E');
	
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(right-(rect.right-rect.left),y,right,y+(rect.bottom-rect.top)),DT_NOCLIP );
	y+=(rect.bottom-rect.top);
	y++;

	dc->SelectObject(theApp.m_fntLargeFont);

	DrawCompass(dc,45,58,41);
	if(dat->Direction<0 || dat->Direction>360)	// dit mag eigenlijk niet voorkomen maar gebeurt toch!
		str =_T("??");
	else
		str.Format(_T("%.0f"),dat->Direction);
	dc->SetTextColor((dat->FillFlags & GFF_DIRECTION)?RGB(0,0,0):COL_NOSIGNAL);
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(45-((rect.right-rect.left)/2),58-((rect.bottom-rect.top)/2),50+((rect.right-rect.left)/2),65+((rect.bottom-rect.top)/2)),DT_NOCLIP );
//	dc->DrawText(str,CRect(6,20,7,21),DT_NOCLIP );


	y=100;//+((rect.bottom-rect.top));
	str = "Speed:";
	dc->SetTextColor((dat->FillFlags & GFF_SPEED)?RGB(0,0,0):COL_NOSIGNAL);
	dc->DrawText(str,CRect(6,y+((rect.bottom-rect.top)/2),50,165),DT_NOCLIP );
	str.Format(_T("%4.1f knots   "),dat->Speed);
	dc->DrawText(str,&rect,DT_CALCRECT );
//	y+=((rect.bottom-rect.top))+1;
//	y=100+((rect.bottom-rect.top));
	dc->DrawText(str,CRect(((r.right)/2)-20,y,50,165),DT_NOCLIP );
	y+=((rect.bottom-rect.top))+1;

	str.Format(_T("%4.1f kmh   "),dat->Speed*KNTS2KMH);
//	dc->SetTextColor((dat->FillFlags & GFF_SPEED)?RGB(0,0,0):RGB(128,128,128));
//	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(((r.right)/2)-20,y,50,165),DT_NOCLIP );
	y+=((rect.bottom-rect.top))+1;

	str.Format(_T("Alt: %.1f mtr     "),dat->Altitude);
	dc->SetTextColor((dat->FillFlags & GFF_ALTITUDE)?RGB(0,0,0):COL_NOSIGNAL);
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(6,y,50,165),DT_NOCLIP );
	y+=((rect.bottom-rect.top))+1;

	int tot,tc;
	tot=tc=0;
	for(int i=0;i<12;i++)
	{
		if(dat->Sats[i].Snr)
		{
			tot+=dat->Sats[i].Snr;	// total signal strength
			tc++;
		}
	}
	if(tc) tot/=tc;

	y+=8;
	dc->SelectObject(theApp.m_fntMediumFont);

	str.Format(_T("Dltn:%d Sats:%d:%d dB   "),(UINT)dat->Dilution,dat->SatCnt,tot);
	dc->SetTextColor((dat->FillFlags & GFF_DILUTION)?(dat->Dilution<theApp.m_fMaxDil?RGB(0,162,0):COL_WEAKSIGNAL):COL_NOSIGNAL);
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(6,y,50,165),DT_NOCLIP );
	y+=((rect.bottom-rect.top))+1;

	dc->SelectObject(old);

	dc->SetTextColor(RGB(0,0,0));
	str.Format(_T("RMC:%d GGA:%d GSA:%d GSV:%d sats,%d dB  "),dat->RmcStatus,dat->GgaStatus,dat->GsaFix-1,dat->SvInView,tot);
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(6,r.bottom-(2*((rect.bottom-rect.top)+1)),50,165),DT_NOCLIP );

/*
	y+=((rect.bottom-rect.top))+1;
	str.Format(_T("%d points logged     "),theApp.m_lstPoints.GetCount());
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(6,y,50,165),DT_NOCLIP );
	y+=((rect.bottom-rect.top))+1;

	
			if(dat->FillFlags & GFF_SPEED)
			{
				m_strSpeed.Format(_T("%.1f"),dat->Speed);
				m_strKmh.Format(_T("%.1f"),dat->Speed*1.8152);
			}
			if(dat->FillFlags & GFF_ALTITUDE)
				m_strAltitude.Format(_T("%.1f Mtr"),dat->Altitude);
			if(dat->FillFlags & GFF_DIRECTION)
				m_strDirection.Format(_T("%.0f"),dat->Direction+0.5);
			//if(dat->FillFlags & GFF_SATCNT)
			//	m_strSatCnt.Format(_T("%d sats"),dat->SatCnt);
			if(dat->FillFlags & GFF_DILUTION)
				m_strVariation.Format(_T("%.1f Mtr"),dat->Dilution);

*/


}


/////////////////////////////////////////////////////////////////////////////
void CChildView::ShowCompass(CPaintDC *dc,CGpsFrame *dat)
{
CString str;
//	str.Format(_T("Hello there the time is: %d:%02d:%02d "),theApp.m_GpsData.hour,theApp.m_GpsData.min,theApp.m_GpsData.second);
//	dc->DrawText(str,CRect(12,12,20,20),DT_NOCLIP );
	// TODO: Add your message handler code here

	CRect r;
	GetClientRect(&r);	

	int rad = ((r.right-r.left)/2)-10;	// radius
	int x,y;
	x = (r.right-r.left)/2;
	y = r.top + x + 6;

	DrawCompass(dc,x,y,rad);

	HGDIOBJ old = dc->SelectObject(theApp.m_fntExtraLargeFont);
	str.Format(_T("%.0f"),theApp.m_GpsData.Direction/*+0.5*/);
RECT rect;
	rect.left=rect.top=0;
	dc->DrawText(str,&rect,DT_CALCRECT );

	dc->SetTextColor((theApp.m_GpsData.RmcStatus&&theApp.m_GpsData.GgaStatus)?RGB(0,0,0):RGB(128,128,128));
	dc->DrawText(str,CRect(x-((rect.right-rect.left)/2),y-((rect.bottom-rect.top)/*/2*/),x+((rect.right-rect.left)/2),y+((rect.bottom-rect.top)/2)),DT_NOCLIP );

	if(theApp.m_iKmh)
		str.Format(_T("%d"),(int)((theApp.m_GpsData.Speed*KNTS2KMH)+0.5));
	else
		str.Format(_T("%.1f"),theApp.m_GpsData.Speed);
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->SetTextColor((theApp.m_GpsData.FillFlags & GFF_SPEED)?RGB(0,0,0):RGB(128,128,128));
	dc->DrawText(str,CRect(x-((rect.right-rect.left)/2),y/*+((rect.bottom-rect.top))*/,x+((rect.right-rect.left)/2),y+((rect.bottom-rect.top)/2)),DT_NOCLIP );

	dc->SelectObject(old);

	str.Format(_T("Direction: %.1f %.1fknts  %.1fkmh"),theApp.m_GpsData.Direction,theApp.m_GpsData.Speed,theApp.m_GpsData.Speed*KNTS2KMH);
	dc->DrawText(str,CRect(12,r.bottom-29,20,20),DT_NOCLIP );
}

/////////////////////////////////////////////////////////////////////////////
void CChildView::DrawCompass(CPaintDC *dc, int x, int y, int rad)
{
	HPEN pen;
	pen = ATL::CreatePen(PS_SOLID,4,RGB(0,0,0));
	HGDIOBJ oldpen = dc->SelectObject(pen);
	dc->Ellipse(x-rad,y-rad,x+rad,y+rad);		// draw circle

	dc->MoveTo(x,y);

	float dir = theApp.m_GpsData.Direction;
	dir *= (float)(3.141592654/180.0);
	dc->LineTo(x-(int)((float)((float)rad * sin(dir))),y-(int)((float)((float)rad * cos(dir))));

	dc->SelectObject(oldpen);
	DeleteObject(pen);

}

/////////////////////////////////////////////////////////////////////////////
void CChildView::ShowTrack(CPaintDC *dc, CGpsFrame *dat)
{
	CRect r;
	GetClientRect(&r);	
	DrawCompass(dc,25,40,23);
	CString str;
//	dc->SelectObject(theApp.m_fntExtraLargeFont);
RECT rect;
	str.Format(_T("%.0f"),dat->Direction);
	dc->SetTextColor((dat->FillFlags & GFF_DIRECTION)?RGB(0,0,0):RGB(128,128,128));
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(25-((rect.right-rect.left)/2),40-((rect.bottom-rect.top)/2),50,65),DT_NOCLIP );

	r.bottom-=14;	// text height
float Amax,Amin,Omax,Omin;
	CGpsPoint *pnt;
	Amin=Omin=361;
	Amax=Omax=0;
	POSITION pos = theApp.m_lstPoints.GetHeadPosition();
	while(pos!=NULL)
	{
		pnt = theApp.m_lstPoints.GetNext(pos);

		if(pnt->m_fLat > Amax) Amax = pnt->m_fLat;
		if(pnt->m_fLat < Amin) Amin = pnt->m_fLat;
		if(pnt->m_fLong > Omax) Omax = pnt->m_fLong;
		if(pnt->m_fLong < Omin) Omin = pnt->m_fLong;

	}
	float xs,ys,scale;
	if(Amax<=Amin || Omax<=Omin)	return;	// no points, no scale
	ys= (float)r.right / (Amax-Amin);
	xs= (float)(r.bottom-28) / (Omax-Omin);
BOOL bx;
	bx = xs<ys? TRUE:FALSE;
	scale = xs<ys? xs:ys;

//	scale /= 1000;
//	scale = (int)scale;
//	scale *=1000;


	dc->SetTextColor(RGB(0,0,0));
	str.Format(_T("Screen %c:%d mtr %d pnts"),bx?'X':'Y',(int)((Amax-Amin)*(60.0*1852.0)), theApp.m_lstPoints.GetCount());
	dc->DrawText(str,CRect((r.right/2)-45,1,20,20),DT_NOCLIP );


	pos = theApp.m_lstPoints.GetHeadPosition();
	pnt = theApp.m_lstPoints.GetNext(pos);

int x,y;
	x=(int)((pnt->m_fLong-Omin)*scale);
	y=r.bottom-(int)((pnt->m_fLat-Amin)*scale);

HGDIOBJ oldpen;
	CPen RedPen,DrawPen;
	RedPen.CreatePen(PS_SOLID,2,RGB(255,0,0));
	DrawPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldpen = dc->SelectObject(&RedPen);
	// draw cross on current position
	dc->Ellipse(x-5,y-5,x+5,y+5);		// draw circle
	dc->MoveTo(x-10,y-10	);
	dc->LineTo(x+10,y+10	);
	dc->MoveTo(x-10,y+10	);
	dc->LineTo(x+10,y-10	);
int step,stepcnt;
	stepcnt = theApp.m_lstPoints.GetCount();
	stepcnt/=1000;
	step=stepcnt;
	dc->SelectObject(DrawPen);
	dc->MoveTo(x,y);
	while(pos!=NULL)
	{
		pnt = theApp.m_lstPoints.GetNext(pos);

		if(pnt->m_strComment.GetLength())
		{
			dc->DrawText(pnt->m_strComment,CRect(x,y,50,65),DT_NOCLIP );
			dc->SelectObject(&RedPen);
			dc->Ellipse(x-3,y-3,x+3,y+3);		// draw circle
			dc->SelectObject(DrawPen);
			step=0;
			
		}
		if(!step)
		{
			x=(int)((pnt->m_fLong-Omin)*scale);
			y=r.bottom-(int)((pnt->m_fLat-Amin)*scale);
			dc->LineTo(x,y);
			step = stepcnt;
		} else step--;
	}
	// draw plus on current position
	oldpen = dc->SelectObject(&RedPen);
	dc->Ellipse(x-5,y-5,x+5,y+5);		// draw circle
	dc->MoveTo(x-10,y);
	dc->LineTo(x+10,y);
	dc->MoveTo(x,y-10);
	dc->LineTo(x,y+10);
	dc->SelectObject(oldpen);

}


/////////////////////////////////////////////////////////////////////////////
void CChildView::DrawString(CPaintDC *dc, int fflag, RECT *pr, CString *pstr)
{
RECT rect;
	dc->DrawText(*pstr,&rect,DT_CALCRECT );
	dc->SetTextColor((fflag&1)?RGB(0,0,0):RGB(128,128,128));
CRect cr;
	if(!(fflag & 0x00F0))	// left allign
		cr = CRect(pr->left,pr->top,pr->left+(rect.right-rect.left),pr->top+(rect.bottom-rect.top));
	if(fflag & 0x0010)		// right allign
		cr = CRect(pr->right-(rect.right-rect.left),pr->top,pr->right,pr->top+(rect.bottom-rect.top));
	if(fflag & 0x0020)		// centre allign
		cr = CRect(pr->right-((rect.right-rect.left)/2),pr->top,pr->right+((rect.right-rect.left)/2),pr->top+(rect.bottom-rect.top));

	dc->DrawText(*pstr,&cr,DT_NOCLIP );
	pr->top+=(rect.bottom-rect.top);

}

/////////////////////////////////////////////////////////////////////////////
void CChildView::ShowSat(CPaintDC *dc, CGpsFrame *dat)
{
CString str;
int y=18;
	dc->SetTextColor(RGB(0,0,0));

	str.Format(_T("Latitude: %f"),dat->Latitude);
	dc->DrawText(str,CRect(4,y,200,39),DT_NOCLIP );
	y+=14;
	str.Format(_T("Longitude: %f"),dat->Longitude);
	dc->DrawText(str,CRect(4,y,200,54),DT_NOCLIP );
	y+=14;
	str.Format(_T("GSA:%s, %s, P:%.1f H:%.1f V:%.1f"),dat->GsaMode=='A'?_T("Auto"):_T("Manual"),dat->GsaFix==1?_T("No fix"):dat->GsaFix==2?_T("2D"):_T("3D"));
	dc->DrawText(str,CRect(4,y,200,54),DT_NOCLIP );
	y+=14;
	str.Format(_T("GSV:%d Messages, %d Satellites in view"),dat->SvMessages,dat->SvInView);
	dc->DrawText(str,CRect(4,y,200,54),DT_NOCLIP );

	for(int i=0;i<12;i++)
	{
		y+=14;
		str.Format(_T("ID:%2d Prn:%2d Elev:%2d Azim:%2d Snr:%2ddB"),
			dat->Sats[i].Id,dat->Sats[i].Prn,dat->Sats[i].Elevation,dat->Sats[i].Azimuth,dat->Sats[i].Snr);  //.Format(_T("Longitude: %f"),dat->Longitude);
		dc->DrawText(str,CRect(4,y,200,68), DT_NOCLIP);//

	}
/*
	y+=14;
	dc->DrawText(dat->GsvFrame,CRect(4,y,200,82), DT_NOCLIP);//
	dc->DrawText(dat->GsvFrame.Right(40),CRect(4,82,200,96), DT_NOCLIP);//
	y+=14;
	dc->DrawText(dat->GsaFrame,CRect(4,y,200,110), DT_NOCLIP);//
	dc->DrawText(dat->GsaFrame.Right(40),CRect(4,110,200,124), DT_NOCLIP);//
*/
}


//double MapX1,MapX2,MapY1,MapY2;

void CChildView::ShowMap(CPaintDC *dc, CGpsFrame *dat)
{
	CDC memDC;
	CRect r;
	CGpsMap *pmap = m_mapCurrent;
	CBitmap *pbmp = &pmap->m_bmpMap;
	HBITMAP hbmp = pmap->m_hbmpMap;
	if(hbmp==NULL) //bmpBackGround.m_hObject)
		return;

	memDC.CreateCompatibleDC (dc);
	void* pOldBitmap = memDC.SelectObject(pmap->m_bmpMap.m_hObject);

	int x,y;
	if(m_bMouseDown)
	{
		y=pmap->m_uY - m_xMove;
		x=pmap->m_uX - m_yMove;
	} else {
		y=pmap->m_uY;
		x=pmap->m_uX;
	}

	GetClientRect(&r);	
	r.bottom-=14;	// text height

//	dc->BitBlt (0, 0, r.right, r.bottom, &memDC, x, y, SRCCOPY);

//	dc->SetStretchBltMode(COLORONCOLOR);
//	StretchAspectRatio(dc, &r,pmap->m_uWidth, pmap->m_uHeight,&memDC);
 	dc->StretchBlt (0, 0, r.right, r.bottom, &memDC,
		x, y, 
		pmap->m_uZoomWidth,pmap->m_uZoomHeight, 
			SRCCOPY);



	DrawCompass(dc,25,24,23);
		CString str;
//	dc->SelectObject(theApp.m_fntExtraLargeFont);
RECT rect;
	str.Format(_T("%.0f"),dat->Direction);
	dc->SetTextColor((dat->FillFlags & GFF_DIRECTION)?RGB(0,0,0):RGB(128,128,128));
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(25-((rect.right-rect.left)/2),25-((rect.bottom-rect.top)/*/2*/),50,65),DT_NOCLIP );

	str.Format(_T("%.1f"),dat->Speed);
	dc->SetTextColor((dat->FillFlags & GFF_SPEED)?RGB(0,0,0):RGB(128,128,128));
	dc->DrawText(str,&rect,DT_CALCRECT );
	dc->DrawText(str,CRect(25-((rect.right-rect.left)/2),25/*-((rect.bottom-rect.top)/2)*/,50,65),DT_NOCLIP );

	// plot position arrow
HGDIOBJ oldpen;
	POINT pnt;
	pmap->Pos2Screen(&pnt,dat->Longitude,dat->Latitude);

	x=pnt.x;
	y=pnt.y;
/*
	float fx = (dat->Longitude-pmap->m_dLong1)/pmap->m_dXDegreePix;
	fx-=x;
	if(fx<0) fx=0;
	if(fx>r.right)	fx=r.right;
	x=(fx/pmap->m_dZoom);
	float fy = pmap->m_uHeight;
		fy-=((dat->Latitude-pmap->m_dLat1)/pmap->m_dYDegreePix);
	fy-=y;
	if(fy<0) fy=0;
	if(fy>r.bottom)	fy=r.bottom;
	y=(fy/pmap->m_dZoom);	
*/

//	CPen RedPen,DrawPen;
//	RedPen.CreatePen(PS_SOLID,2,RGB(255,0,0));
//	DrawPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldpen = dc->SelectObject(&m_RedPen);
	// draw arrow on current position
	int rad=20;
//	dc->Ellipse(x-rad,y-rad,x+rad,y+rad);		// draw circle

	float dir = theApp.m_GpsData.Direction;
	float a,b;
	a=dir+145; if(a>=360) a-=360;
	a*=(float)(3.141592654/180.0);
	b=dir+215; if(b>=360) b-=360;
	b*=(float)(3.141592654/180.0);
	dir *= (float)(3.141592654/180.0);

	dc->MoveTo(x+(int)((float)((float)rad * sin(a))),y-(int)((float)((float)rad * cos(a))));
	dc->LineTo(x,y);
//	dc->LineTo(x+(int)((float)((float)rad * sin(dir))),y-(int)((float)((float)rad * cos(dir))));
	dc->LineTo(x+(int)((float)((float)rad * sin(b))),y-(int)((float)((float)rad * cos(b))));

	// plot track
	BOOL newtrack=TRUE;
	CGpsPoint *point;
	POSITION pos = theApp.m_lstPoints.GetHeadPosition();
	while(pos!=NULL)
	{
		point = theApp.m_lstPoints.GetNext(pos);

		pmap->Pos2Screen(&pnt,point->m_fLong,point->m_fLat);
		
		if(!(pnt.x<0 || pnt.x>r.right || pnt.y<0 || pnt.y>r.bottom))
		{
			if(newtrack){
				newtrack=FALSE;
				dc->MoveTo(pnt);
			} else
				dc->LineTo(pnt);

		} else newtrack=TRUE;
	}

	// plot direction line
	dc->SelectObject(m_DrawPen);
	dc->MoveTo(x,y);
	rad=150;
	dc->LineTo(x+(int)((float)((float)rad * sin(dir))),y-(int)((float)((float)rad * cos(dir))));


	dc->SelectObject(oldpen);
}

/////////////////////////////////////////////////////////////////////////////
void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_bMouseDown = TRUE;
	m_xMove=0;
	m_yMove=0;
	m_pntMouseStart = point;
	CWnd ::OnLButtonDown(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
void CChildView::OnLButtonUp(UINT nFlags, CPoint point) 
{
CMainFrame *pFrame;
	m_bMouseDown = FALSE;
	m_xMove=0;
	m_yMove=0;
	pFrame = (CMainFrame *)theApp.m_pMainWnd;
	if(theApp.m_iViewType==5)
	{
		if(point.y<50)
		{
			if(point.y<25)
			{
				m_mapCurrent->m_dZoom+=0.1;
			} else {
				m_mapCurrent->m_dZoom-=0.1;
				if(m_mapCurrent->m_dZoom<0.5) m_mapCurrent->m_dZoom = 0.5;
			}
			RECT r;
			GetClientRect(&r);
			m_mapCurrent->ZoomMap(&r);


		} else {
			if(point!=m_pntMouseStart)
			{
				m_mapCurrent->m_uY -= (point.y-m_pntMouseStart.y);
				m_mapCurrent->m_uX -= (point.x-m_pntMouseStart.x);
			} else 
				theApp.m_iViewType++;
		}
	} else 	
		theApp.m_iViewType++;

	pFrame->m_wndView.Invalidate(TRUE);
	CWnd ::OnLButtonUp(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
void CChildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
		m_xMove = (point.y-m_pntMouseStart.y);
		m_yMove = (point.x-m_pntMouseStart.x);
	
	CWnd ::OnMouseMove(nFlags, point);
}

int CChildView::PositionMap(void)
{
	if(theApp.m_iViewType==5 && m_mapCurrent!=NULL)
	{
		CGpsFrame *dat = &theApp.m_GpsData;
		RECT r;

		GetClientRect(&r);	
		r.bottom-=14;	// text height

		CGpsMap *smalmap = theApp.FindMap();// is there a beter map?

		if(smalmap!=NULL && smalmap!=m_mapCurrent)
		{
				m_mapCurrent = smalmap;
				SetCursor(::LoadCursor(NULL, IDC_WAIT));
				m_mapCurrent->LoadBitmap();
				SetCursor(::LoadCursor(NULL, IDC_ARROW));
				m_mapCurrent->ZoomMap(&r);
				Invalidate(TRUE);
		}


		// calc start of bitmap position in pixels in the bitmap
		m_mapCurrent->m_uX = (((dat->Longitude - (m_mapCurrent->m_dScrnLong/2.0))-
						m_mapCurrent->m_dLong1)/m_mapCurrent->m_dXDegreePix);
		m_mapCurrent->m_uY = ((m_mapCurrent->m_dLat2-
				(dat->Latitude+(m_mapCurrent->m_dScrnLat/2.0)))/m_mapCurrent->m_dYDegreePix);

	}
	return 0;
}
