// GpsFrame.cpp: implementation of the CGpsFrame class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "embeddedgps.h"
#include "GpsFrame.h"
#include "MainFrm.h"
#include "DlgWayPoint.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGpsFrame::CGpsFrame()
{
	FillFlags = 0;
	m_iBufIdx = 0;
	m_hCom=NULL;
	m_hLog=NULL;

}

CGpsFrame::~CGpsFrame()
{

}




/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::AnalyzeFrame(CString frame)
{
int FrameTabRMC[] = { 1,2,3,4,5,6,7,8,9,10,11,0,0,0,0,0 };				// My field numbers
int FrameTabGGA[] = { 1,2,3,4,5,12,13,14,15,16,17,18,19,20,0,0,0,0 };
int FrameTabGSA[] = { 21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,0,0,0,0 };
int FrameTabGSV[] = { 38,39,40,41,45,49,53,42,46,50,54,43,47,51,55,44,48,52,56,0,0,0,0 };
int *FieldTab;
int here,f;
int field;
int ok;
CString sF;

	if(frame.Find(_T("RMC"),0)>0)  // analyze RMC frame
		FieldTab = FrameTabRMC;
	else
		if(frame.Find(_T("GGA"),0)>0)  // analyze GGA frame
			FieldTab = FrameTabGGA;
		else 
			if(frame.Find(_T("GSV"),0)>0)  // analyze GSV frame
			{	FieldTab = FrameTabGSV;
				GsvFrame = frame;
				//return 0;
			}else 
			if(frame.Find(_T("GSA"),0)>0)  // analyze GSV frame
			{	FieldTab = FrameTabGSA;
				GsaFrame = frame;
				//return 0;
			}else 
				return 0;		// not interrested

	if(Direction<0 || Direction>360) Direction=0;
	here=0;
	field=0;
//	FillFlags=0;
	ok=TRUE;
	while( (here=frame.Find(_T(","),here))>=0 )	// scan fields ,Sep
	{
		here++;
		sF = frame.Mid(here);
		f = sF.Find(_T(","),0);
		if(f>=0)
			sF=sF.Left(f);
		FillFlags |= ReadField(sF,FieldTab[field++]);
	}
	if(!FillFlags)
		ok=FALSE;
	return ok;
}

/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::ReadField(CString sF, int field)
{
int updated;
int lat,i;
	updated=0;
	if(sF.GetLength() && sF.GetAt(0)!=',')
	switch(field)
	{
// RMC
		case 1:		//	UTC of position fix
			if(swscanf(LPCTSTR(sF),_T("%02d%02d%02d"),&hour,&min,&second)==3)
			{
				hour+=theApp.m_iutc;
				if(hour<0) hour+=24;
				if(hour>23) hour-=24;
				updated |= GFF_TIME;
	//			m_strTime = sF.Left(2)+_T(":")+sF.Mid(2,2)+_T(":")+sF.Mid(4,2)+_T("  ");
			}
			break;
		case 2:		//	Data status (V=navigation receiver warning)
			RmcStatus = sF.GetAt(0)=='V' ? 0 : 1;
			updated |= GFF_RMCSTATUS;
			break;
		case 3:		//	Latitude of fix
			if(swscanf(LPCTSTR(sF.Left(2)),_T("%2d"),&lat)==1)
				if(swscanf(LPCTSTR(sF.Mid(2)),_T("%f"),&Latitude)==1)
				{
					Latitude /= 60.0;
					Latitude += lat;
					//	m_strLatitude = sF.Left(2)+_T("")+sF.Mid(2)+_T("'");
				}
			break;
		case 4:		//	N or S
			if(Latitude>=0 && Latitude<90.001)
				updated |= GFF_LATITUDE;
			if(sF.GetAt(0)=='S')
				Latitude = -Latitude;
			//	m_strLatitude += sF;
			break;
		case 5:		//	Longitude of fix
			if(swscanf(LPCTSTR(sF.Left(3)),_T("%3d"),&lat)==1)
				if(swscanf(LPCTSTR(sF.Mid(3)),_T("%f"),&Longitude)==1)
				{
					//swscanf(LPCTSTR(sF),_T("%3d%f"),&lat,&Longitude);
					Longitude /= 60.0;
					Longitude += lat;
					//	m_strLongitude = sF.Left(3)+_T("")+sF.Mid(3)+_T("'");
				}
			break;
		case 6:		//	E or W
			if(Longitude>=0 && Longitude<180.001)
				updated |= GFF_LONGITUDE;
			if(sF.GetAt(0)=='W')
				Longitude = -Longitude;
			//m_strLongitude += sF;
			break;
		case 7:		//	Speed over ground in knots
			swscanf(LPCTSTR(sF),_T("%f"),&Speed);
			updated |= GFF_SPEED;
		//	m_strSpeed = sF+" knots";
			break;
		case 8:		//	Track made good in degrees True
			swscanf(LPCTSTR(sF),_T("%f"),&Direction);
			updated |= GFF_DIRECTION;
		//	m_strDirection = sF;
			break;
		case 9:		//	UTC date
			swscanf(LPCTSTR(sF),_T("%02d%02d%02d"),&day,&month,&year);
			year+=2000;
			updated |= GFF_DATE;
			//m_strTime += sF.Left(2)+_T("-")+sF.Mid(2,2)+_T("-20")+sF.Mid(4,2);
			break;
		case 10:		//	Magnetic variation degrees (Easterly var. subtracts from true course)
			swscanf(LPCTSTR(sF),_T("%f"),&Variation);
			updated |= GFF_VARIATION;
	//		m_strVariation = sF;
			break;
		case 11:		//	E or W
			if(sF.GetAt(0)=='W')
				Variation = -Variation;
	//		m_strVariation += sF;
			break;


// GGA


		case 12:		//	GPS quality indicator (0=invalid; 1=GPS fix; 2=Diff. GPS fix)
			GgaStatus = sF.GetAt(0)-'0';
			updated |= GFF_GGASTATUS;
	//		m_strSatCnt = sF + ", ";
	//		if(sF.GetAt(0)=='0')
	//			ok=FALSE;
			break;
		case 13:		//	Number of satellites in use [not those in view]
			swscanf(LPCTSTR(sF),_T("%02d"),&SatCnt);
			updated |= GFF_SATCNT;
		//	m_strSatCnt += sF;
			break;
		case 14:		//	Horizontal dilution of position
			swscanf(LPCTSTR(sF),_T("%f"),&Dilution);
			updated |= GFF_DILUTION;
		//	m_strSatCnt += " :"+sF;
			break;
		case 15:		//	Antenna altitude above/below mean sea level (geoid)
			swscanf(LPCTSTR(sF),_T("%f"),&Altitude);
			updated |= GFF_ALTITUDE;
		//	m_strAltitude = sF+"M";
			break;
		case 16:		//	Meters  (Antenna height unit)
			if(Altitude<0 || Altitude>10000) Altitude=0;
//			if(m_strAltitude.GetLength())
//				m_strAltitude += sF;
			break;
		case 17:		//	Geoidal separation (Diff. between WGS-84 earth ellipso
			break;
		case 18:		//	Meters  (Units of geoidal separation)
			break;
		case 19:		//	Age in seconds since last update from diff. 
			break;
		case 20:		//	Diff. reference station ID#
			break;

// GSA

		case 21:
			GsaMode = sF.GetAt(0);	// M=manual A=automatic
			for(i=0;i<12;i++) Sats[i].Id=0;
			Pdop=0; Hdop=0; Vdop=0;
			break;
		case 22:
			GsaFix = sF.GetAt(0)-'0'; // 1=Nofix 2=2D  3=3D
			updated |= GFF_GSA;
			break;
		case 23:
		case 24:
		case 25:
		case 26:
		case 27:
		case 28:
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
			swscanf(LPCTSTR(sF),_T("%2d"),&Sats[field-23].Id);	// IDs of SVs used in position fix (null for unused fields)
			break;
		case 35:
			swscanf(LPCTSTR(sF),_T("%f"),&Pdop);
			break;
		case 36:
			swscanf(LPCTSTR(sF),_T("%f"),&Hdop);
			break;
		case 37:
			swscanf(LPCTSTR(sF),_T("%f"),&Vdop);
			break;


// GSV

		case 38:
			swscanf(LPCTSTR(sF),_T("%2d"),&SvMessages);
			break;
		case 39:
			swscanf(LPCTSTR(sF),_T("%2d"),&SvMessage);
			break;
		case 40:
			swscanf(LPCTSTR(sF),_T("%2d"),&SvInView);
			break;
		case 41:
		case 42:
		case 43:
		case 44:
			if(SvMessage && SvMessage<4)
				swscanf(LPCTSTR(sF),_T("%2d"),&Sats[((SvMessage-1)<<2)+(field-41)].Prn);
			break;
		case 45:
		case 46:
		case 47:
		case 48:
			if(SvMessage && SvMessage<4)
				swscanf(LPCTSTR(sF),_T("%2d"),&Sats[((SvMessage-1)<<2)+(field-45)].Elevation);
			break;
		case 49:
		case 50:
		case 51:
		case 52:
			if(SvMessage && SvMessage<4)
				swscanf(LPCTSTR(sF),_T("%2d"),&Sats[((SvMessage-1)<<2)+(field-49)].Azimuth);
			break;
		case 53:
		case 54:
		case 55:
		case 56:
			if(SvMessage && SvMessage<4)
				swscanf(LPCTSTR(sF),_T("%2d"),&Sats[((SvMessage-1)<<2)+(field-53)].Snr);
			break;

	}
	return updated;
}
/*
$GPGSA,A,3,19,28,14,18,27,22,31,39,,,,,1.7,1.0,1.3*35

GSA  = GPS receiver operating mode, SVs used for navigation, and DOP values.

1    = Mode:
       M=Manual, forced to operate in 2D or 3D
       A=Automatic, 3D/2D
2    = Mode:
       1=Fix not available
       2=2D
       3=3D
3-14 = IDs of SVs used in position fix (null for unused fields)
15   = PDOP
16   = HDOP
17   = VDOP
--------------------------------------------------------------------------------
GSV 
$GPGSV,4,1,13,02,02,213,,03,-3,000,,11,00,121,,14,13,172,05*67 
GSV  = Number of SVs in view, PRN numbers, elevation, azimuth & SNR values. 

1    = Total number of messages of this type in this cycle 
2    = Message number 
3    = Total number of SVs in view 
4    = SV PRN number 
5    = Elevation in degrees, 90 maximum 
6    = Azimuth, degrees from true north, 000 to 359 
7    = SNR, 00-99 dB (null when not tracking) 
8-11 = Information about second SV, same as field 4-7 
12-15= Information about third SV, same as field 4-7 
16-19= Information about fourth SV, same as field 4-7 


*/
 /*  RMC - Recommended minimum specific GPS/Transit data
        RMC,225446,A,4916.45,N,12311.12,W,000.5,054.7,191194,020.3,E*68
           225446       Time of fix 22:54:46 UTC
           A            Navigation receiver warning A = OK, V = warning
           4916.45,N    Latitude 49 deg. 16.45 min North
           12311.12,W   Longitude 123 deg. 11.12 min West
           000.5        Speed over ground, Knots
           054.7        Course Made Good, True
           191194       Date of fix  19 November 1994
           020.3,E      Magnetic variation 20.3 deg East
           *68          mandatory checksum
*/
/*
GGA    111111111 2222222 3 44444444 5 6 77 888 999    11    13  14    
$GPGGA,hhmmss.ss,llll.ll,a,yyyyy.yy,a,x,xx,x.x,x.x,M,x.x,M,x.x,xxxx*hh

GGA  = Global Positioning System Fix Data

1    = UTC of Position
2    = Latitude
3    = N or S
4    = Longitude
5    = E or W
6    = GPS quality indicator (0=invalid; 1=GPS fix; 2=Diff. GPS fix)
7    = Number of satellites in use [not those in view]
8    = Horizontal dilution of position
9    = Antenna altitude above/below mean sea level (geoid)
10   = Meters  (Antenna height unit)
11   = Geoidal separation (Diff. between WGS-84 earth ellipsoid and
       mean sea level.  -=geoid is below WGS-84 ellipsoid)
12   = Meters  (Units of geoidal separation)
13   = Age in seconds since last update from diff. reference station
14   = Diff. reference station ID#
15   = Checksum

int WriteString(HANDLE file, CString *str)
{
DWORD num;
	char ch;
	for(int u=0;u<str->GetLength();u++)
	{
		ch = (char)str->GetAt(u);
		WriteFile(file, &ch, 1,&num,NULL);
		if(num!=1)
			return FALSE;
	}
	return TRUE;
}
*/

/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::StoreFrame()
{
	CString Out;
	if(Dilution>theApp.m_fMaxDil) return FALSE;  //don't store inaccurate positions

	if(m_hLog==NULL)
		if(!StartLog())
			return FALSE;

	if(m_iLogCnt++==0)
	{
/*		LogPlaceMark(0); 
		// start track
		Out = "<Placemark><name>Track1</name><description> </description><styleUrl>#yellowLineGreenPoly</styleUrl>\n";
		Out += "<LineString><extrude>1</extrude><tessellate>1</tessellate><altitudeMode>absolute</altitudeMode>\n";
		Out += "<coordinates>\n";
		WriteString( &Out);
*/
	}
//	Out.Format(_T("%f,%f,%f\n"), Longitude, Latitude, Altitude);
	m_SecCounter=0;
	LastStoredDirection = Direction;
//	WriteString( &Out);

	int t = (hour*3600)+(min*60)+second;
	int p = (LastPlaceMrkHr*3600)+(LastPlaceMrkMn*60);
	if(t<p) t+= (24*3600);	// next day?
	if( (p-t) >  (30*60))
	{
//		LogPlaceMark(0);	
	}

	CGpsPoint *pnt;
	pnt = new CGpsPoint;

	pnt->m_fLat = Latitude;
	pnt->m_fLong = Longitude;
	pnt->m_fAltitude=Altitude;
	pnt->m_fSpeed=Speed;
	pnt->m_fDirection=Direction;
	pnt->m_fDilution=Dilution;
	pnt->hour=hour;
	pnt->min=min;
	pnt->second=second;
	pnt->m_strComment.Empty();

	theApp.m_lstPoints.AddTail(pnt);
	pnt->Write(m_hLog);

	return  TRUE;
}

//DEL void CGpsFrame::StartFile(HANDLE hLog, CString filename)
//DEL {
//DEL CString s;
//DEL 	m_iLogCnt = 0;
//DEL 	s = "<?xml version=\x22\x31.0\x22 encoding=\x22UTF-8\x22?><kml xmlns=\x22http://earth.google.com/kml/2.1\x22>\n";
//DEL 	s += "<Document>\n<name>"+filename+"</name>\n";
//DEL 	s += "<description>GpsTrack collected with PocketGps on mobile. </description>\n<Style id=\x22yellowLineGreenPoly\x22>";
//DEL 	s += "<LineStyle><color>7f00ffff</color><width>4</width></LineStyle>";
//DEL 	s += "<PolyStyle><color>7f00ff00</color></PolyStyle></Style>\n";
//DEL 	WriteString(hLog, &s); 
//DEL 
//DEL }

//DEL void CGpsFrame::EndFile(HANDLE file)
//DEL {
//DEL 	CString s;
//DEL 	s.Format(_T("%f,%f,%f\n"), Longitude, Latitude, Altitude);
//DEL 	s += "</coordinates></LineString></Placemark>";
//DEL 	WriteString(file,&s);  
//DEL 
//DEL 	LogPlaceMark(file);  // placemark at destination
//DEL 
//DEL 	s = "</Document></kml>\n";
//DEL 	WriteString(file,&s);  
//DEL 
//DEL }

/////////////////////////////////////////////////////////////////////////////
void CGpsFrame::LogPlaceMark(UINT Flags)
{
	CString s,n;

	n.Format(_T("PocketGPS Log %4d-%02d-%02d %2d:%02d:%02d"),year,month,day,hour,min,second);

	if(Flags)
	{
		CDlgWayPoint dlg;
		dlg.m_strName = n;
		dlg.m_strLatitude.Format(_T("%f"),Latitude);
		dlg.m_strLongitude.Format(_T("%f"),Longitude);
		if(!dlg.DoModal())
			return;

		n = dlg.m_strName;

		CGpsPoint *pnt;
		pnt = new CGpsPoint;
		pnt->m_fLat = Latitude;
		pnt->m_fLong = Longitude;
		pnt->m_fAltitude=Altitude;
		pnt->m_fSpeed=Speed;
		pnt->m_fDirection=Direction;
		pnt->m_fDilution=Dilution;
		pnt->hour=hour;
		pnt->min=min;
		pnt->second=second;
		pnt->m_strComment = n;
		pnt->Write(m_hLog);
		theApp.m_lstPoints.AddTail(pnt);


	}

/*
	s = "</coordinates></LineString></Placemark>\n<Placemark>";
	WriteString(&s);  
	s += "<name>" + n + "</name>\n";

	n.Format(_T("PocketGPS Log %4d-%02d-%02d %2d:%02d:%02d"),year,month,day,hour,min,second);
	s += "<description>" + n + "</description>>\n";
/ *
<LookAt>
<longitude>19.95893700035145</longitude>
<latitude>39.6154899551724</latitude>
<altitude>0</altitude>
<range>32555.45937659599</range>
<tilt>0</tilt>
<heading>1.978931753560007</heading>
</LookAt>
* /
	s += "<styleUrl>#default_copy0+nicon=http://maps.google.com/mapfiles/kml/pal3/icon63.png+hicon=http://maps.google.com/mapfiles/kml/pal3/icon55.png</styleUrl>\n";
	s += "<Point>\n<coordinates>";
	n.Format(_T("%f,%f,%f"), Longitude, Latitude, Altitude);
	s += n + "</coordinates>\n</Point></Placemark>\n";
	WriteString(&s);  

	s = "<Placemark><name>Track1</name><description> </description><styleUrl>#yellowLineGreenPoly</styleUrl>\n";
	s += "<LineString><extrude>1</extrude><tessellate>1</tessellate><altitudeMode>absolute</altitudeMode>\n";
	s += "<coordinates>\n";
	WriteString( &s);
*/
	LastPlaceMrkHr = hour;
	LastPlaceMrkMn = min;
}

/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::Connect(CString Com, int baud)
{
	DCB dcb;
	CString s;
	if(m_hCom)
		CloseHandle(m_hCom);
	m_hCom = CreateFile( Com,
	    GENERIC_READ | GENERIC_WRITE,
	    0,    // comm devices must be opened w/exclusive-access 
	    NULL, // no security attributes 
	    OPEN_EXISTING, // comm devices must use OPEN_EXISTING 
	    0,    // not overlapped I/O 
		NULL  // hTemplate must be NULL for comm devices 
		);
	if (m_hCom == INVALID_HANDLE_VALUE) 
	{
		m_hCom=NULL;
		s.Format(_T("Kan %s niet openen"),Com);
		AfxMessageBox(LPCTSTR(s),MB_OK|MB_SETFOREGROUND);
		return FALSE;
	}
	if (!GetCommState(m_hCom, &dcb))
	{
		CloseHandle(m_hCom);
		m_hCom=NULL;
		s.Format(_T("Kan geen status opvragen"));
		AfxMessageBox(LPCTSTR(s),MB_OK|MB_SETFOREGROUND);
		return FALSE;
	}
//	bufidx=0;
/*
  DCB dcb;
  dcb.DCBlength = sizeof(DCB);

  ret = FALSE;
  if(GetCommState(hComDev, &dcb))
  {
		dcb.BaudRate          = 57600; //19200;
		dcb.ByteSize          = 8;
		dcb.Parity            = NOPARITY;
		dcb.StopBits          = ONESTOPBIT;
		dcb.fBinary           = 1;
		dcb.fParity           = 0;
		dcb.fErrorChar        = 0;
		dcb.fOutxCtsFlow      = 0;
		dcb.fOutxDsrFlow      = 0;
		dcb.fDtrControl       = DTR_CONTROL_DISABLE;
		dcb.fDsrSensitivity   = 0;
		dcb.fOutX             = 0;
		dcb.fInX              = 0;
		dcb.fNull             = 0; // do not discard null chars!!
		dcb.fRtsControl       = RTS_CONTROL_DISABLE;  // disable for rs232 -> lbus
		dcb.fAbortOnError     = 0;
		//  dcb.fAbortOnError     = 1;
		if (SetCommState(hComDev, &dcb))
			ret = TRUE;
  }

*/	
	dcb.BaudRate = baud;
	dcb.ByteSize = 8;
	dcb.Parity   = NOPARITY;
	dcb.StopBits = ONESTOPBIT;//1;
		dcb.fDtrControl       = DTR_CONTROL_DISABLE;
		dcb.fRtsControl       = RTS_CONTROL_DISABLE;  // disable for rs232 -> lbus
	
	if (!SetCommState(m_hCom, &dcb))
	{
		CloseHandle(m_hCom);
		m_hCom=NULL;
		AfxMessageBox(_T("Kan de poort niet instellen"),MB_OK|MB_SETFOREGROUND);
		return FALSE;
	}

	m_iBufIdx=0;
	// TODO: Wait for a GPS frame

	return TRUE;

	/*
	*/

}

/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::StartLog()
{
	SYSTEMTIME st;
	GetLocalTime(&st);

	

CString s;
////time_t osBinaryTime;  // C run-time time (defined in <time.h>)
//tm osBinaryTime;  // C run-time time (defined in <time.h>)

	if(m_hLog)
		EndLog();

////	osBinaryTime = WCE_FCTN(time) (NULL) ;  // Get the current time from      // the operating system.
//	ATL::CTime atime; //( osBinaryTime );  //,date;
//	atime.GetLocalTm(&osBinaryTime); //.GetCurrentTime();
////	s.Format(_T("GPSLog_%4d-%02d-%02d_%02d%02d.kml"),time.GetYear(),time.GetMonth(),time.GetDay(),
////		time.GetHour(),time.GetMinute());
//	s.Format(_T("\\Storage card\\GPS\\GPSLog_%4d-%02d-%02d_%02d%02d.gpd"),atime.GetYear(),atime.GetMonth(),atime.GetDay(),
//		atime.GetHour(),atime.GetMinute());

	s.Format(_T("\\Storage card\\GPS\\GPSLog_%4d-%02d-%02d_%02d%02d.gpd"),st.wYear,st.wMonth,st.wDay,
		st.wHour,st.wMinute);

	m_Filename=s;
	s+=_T(".gpd");

	m_hLog = CreateFile( s, //_T("LogFile.txt"),
	    GENERIC_READ | GENERIC_WRITE,
	    0,    // comm devices must be opened w/exclusive-access 
	    NULL, // no security attributes 
	    CREATE_ALWAYS, //OPEN_EXISTING, // comm devices must use OPEN_EXISTING 
	    FILE_ATTRIBUTE_NORMAL,    // not overlapped I/O 
		NULL  // hTemplate must be NULL for comm devices 
		);
	if (m_hLog == INVALID_HANDLE_VALUE) 
	{
		m_hLog=NULL;
		AfxMessageBox(_T("Kan logfile in \\Storage card\\GPS\\ niet openen"),MB_OK|MB_SETFOREGROUND);
		return FALSE;
	}
	m_iLogCnt = 0;
	m_SecCounter=0;
	LastStoredDirection = -10.0;

	char chbuf[7] = "GPD\x0D\x0A\x1A";
ULONG num;
	WriteFile(m_hLog, chbuf, 6,&num,NULL);
//	file.Write(chbuf,6);
	UINT i=0;
//	file.Write(&i,sizeof(UINT));
	WriteFile(m_hLog, &i, sizeof(UINT),&num,NULL);

	/*
	s = "<?xml version=\x22\x31.0\x22 encoding=\x22UTF-8\x22?><kml xmlns=\x22http://earth.google.com/kml/2.1\x22>\n";
	s += "<Document>\n<name>"+m_Filename+"</name>\n";
	s += "<description>GpsTrack collected with PocketGps on mobile. </description>\n<Style id=\x22yellowLineGreenPoly\x22>";
	s += "<LineStyle><color>7f00ffff</color><width>4</width></LineStyle>";
	s += "<PolyStyle><color>7f00ff00</color></PolyStyle></Style>\n";
	WriteString( &s); 
	*/

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::EndLog()
{
	if(!m_hLog)	return FALSE;
/*
	CString s="";
	if(m_iLogCnt)
		s.Format(_T("%f,%f,%f\n"), Longitude, Latitude, Altitude);
	s += "</coordinates></LineString></Placemark>";
	WriteString(&s);  

	if(m_iLogCnt>1)
		LogPlaceMark(0);  // placemark at destination

	s = "</Document></kml>\n";
	WriteString(&s);  
*/
	CloseHandle(m_hLog);

CString s;
	s = m_Filename;
	s+=_T(".kml");

	theApp.SaveKml(&s);
//	AfxMessageBox("Google KML file saved!",MB_OK|MB_SETFOREGROUND);
	m_hLog=NULL;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
void CGpsFrame::ReadGpsData()
{
DWORD dwError;
COMSTAT cstat;
char ch;
CString strframe;

	m_SecCounter++;

	ClearCommError(m_hCom,&dwError,&cstat);	// check serial status
	FillFlags=0;
	RmcStatus=0;
	GgaStatus=0;
	if (cstat.cbInQue) 
	{
		do
		{
			ReadFile(m_hCom, &ch, 1, &dwError, NULL);
			if(ch=='$')		//Start of Frame
				m_iBufIdx=0;
			m_Buffer[m_iBufIdx++]=ch;
			if(m_iBufIdx>1024)
				m_iBufIdx=0;
			if(ch==0x0A)  // LF = END OF FRAME
			{
				m_Buffer[m_iBufIdx-1]=0;
				strframe = m_Buffer;
				AnalyzeFrame(strframe);
				m_iBufIdx=0;
			}
			ClearCommError(m_hCom,&dwError,&cstat);	// check serial status
		} while(cstat.cbInQue);
	}
}

/////////////////////////////////////////////////////////////////////////////
int CGpsFrame::WriteString(CString *str)
{
DWORD num;
	char ch;
	if(m_hLog==NULL)
		return FALSE;
	for(int u=0;u<str->GetLength();u++)
	{
		ch = (char)str->GetAt(u);
		WriteFile(m_hLog, &ch, 1,&num,NULL);
		if(num!=1)
			return FALSE;
	}
	return TRUE;

}
