// GpsFrame.h: interface for the CGpsFrame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GPSFRAME_H__CA92E284_9920_460B_849B_4A05D9695EA1__INCLUDED_)
#define AFX_GPSFRAME_H__CA92E284_9920_460B_849B_4A05D9695EA1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
class CGpsPoint
{
	CGpsTrack();
	virtual ~CGpsTrack();

	float	m_fLat,m_fLong
	float m_fAltitude;
	float m_fSpeed;
	float m_fDirection;
	float m_fDilution;

	UCHAR hour,min,second;

	CString m_strComment;
}

class CSatelite  
{
public:
	CSatelite();
	virtual ~CSatelite();

	int ID;
	int SV;
	float elevation;
	float azimuth;
	float SNR;
}
*/

typedef struct SSatelite
{
	int Id;					//	GSA frame ids
	int Prn;					//
	int Elevation;			// 0-90
	int Azimuth;			// 0-359
	int Snr;					// 0-99 dB
} SSatelite;

class CGpsFrame  
{
public:
	int LastPlaceMrkMn;
	int LastPlaceMrkHr;
	int WriteString(CString *str);
	int m_iBufIdx;
	UCHAR m_Buffer[1024];
	void ReadGpsData();
	int EndLog();
	int StartLog();
	HANDLE m_hCom;
	HANDLE m_hLog;
	CString m_Filename;

	int Connect(CString Com, int baud);
	void LogPlaceMark(UINT Flags);
	int m_iLogCnt;
	int StoreFrame();
	int ReadField(CString data, int field);
	int AnalyzeFrame(CString frame);
	CGpsFrame();
	virtual ~CGpsFrame();

	int FillFlags;		// what is filled?
	int m_SecCounter;

	float Latitude;
	float Longitude;
	int SecLastSave;
	float Altitude;
	float Speed;
	float Direction;
	float LastStoredDirection;
	int hour,min,second,year,month,day;
	float Variation;
	float Dilution;
	int SatCnt;
	int RmcStatus;
	int GgaStatus;

	// GSA frame data
	char GsaMode,GsaFix;
	float Pdop,Hdop,Vdop;


	// GSV frames
	char SvMessages,
		SvMessage,
		SvInView;
	SSatelite Sats[12];

	CString GsvFrame;
	CString GsaFrame;
//	CSatelite Satelites[16];
};
int WriteString(HANDLE file, CString *str);

#define GFF_LATITUDE		0x0001
#define GFF_LONGITUDE	0x0002
#define GFF_ALTITUDE		0x0004
#define GFF_SPEED			0x0008
#define GFF_DIRECTION	0x0010
#define GFF_TIME			0x0020
#define GFF_DATE			0x0040
#define GFF_VARIATION	0x0080
#define GFF_SATCNT		0x0100
#define GFF_SATDAT		0x0200
#define GFF_RMCSTATUS	0x0400
#define GFF_GGASTATUS	0x0800
#define GFF_DILUTION		0x1000
#define GFF_GSA			0x2000
/*
#define GFF_	0x1000
#define GFF_	0x2000
#define GFF_	0x4000
*/
#endif // !defined(AFX_GPSFRAME_H__CA92E284_9920_460B_849B_4A05D9695EA1__INCLUDED_)
