// GpsMap.cpp : implementation file
//

#include "stdafx.h"
#include "embeddedgps.h"
#include "GpsMap.h"

BOOL LoadBitmapFile(HDC hDC, HBITMAP *hBmpSaved, CString *file);


// CGpsMap

CGpsMap::CGpsMap()
{
	m_dZoom = 1.0;
}

CGpsMap::~CGpsMap()
{
}



// CGpsMap member functions

int CGpsMap::GetFilenamePosition(void)
{
	int a,b,c,d,am,bm,cm,dm,as,bs,cs,ds;
CString cx; 
	a = m_sFilename.Find('X');
	m_dLong1 = 0.0; //4G22M
	m_dLong2 = 0.0; //4G30M
	m_dLat1 = 0.0; //52G19M
	m_dLat2 = 0.0; //52G31M

	if(a==-1)
		return 0;
	cx = m_sFilename.Right(m_sFilename.GetLength()-a);

	if(cx.Find('S')!=-1)
	{
		swscanf(LPCTSTR(cx),_T("X%dG%dM%dS_%dG%dM%dSY%dG%dM%dS_%dG%dM%dS"),&a,&am,&as,&b,&bm,&bs,&c,&cm,&cs,&d,&dm,&ds);

	} else {
		as=0;
		bs=0;
		cs=0;
		ds=0;
		swscanf(LPCTSTR(cx),_T("X%dG%dM_%dG%dMY%dG%dM_%dG%dM"),&a,&am,&b,&bm,&c,&cm,&d,&dm);
	}

//	cs.Format(_T("X%dG%dM_%dG%dMY%dG%dM_%dG%dM"),a,am,b,bm,c,cm,d,dm);
	if(a<0)
		m_dLong1 = (double)a - (((double)am/60.0) + ((double)as/3600.0)); //4G22M
	else
		m_dLong1 = (double)a + (((double)am/60.0) + ((double)as/3600.0)); //4G22M
	if(b<0)
		m_dLong2 = (double)b - (((double)bm/60.0) + ((double)bs/3600.0)); //4G30M
	else
		m_dLong2 = (double)b + ((double)bm/60.0) + ((double)bs/3600.0); //4G30M
	if(c<0)
		m_dLat1 = (double)c - (((double)cm/60.0) + ((double)cs/3600.0)); //52G19M
	else
		m_dLat1 = (double)c + ((double)cm/60.0) + ((double)cs/3600.0); //52G19M
	if(d<0)
		m_dLat2 = (double)d - (((double)dm/60.0) + ((double)ds/3600.0)); //52G31M
	else
		m_dLat2 = (double)d + ((double)dm/60.0) + ((double)ds/3600.0); //52G31M

	double t;
	if(m_dLong1>m_dLong2)
	{
		t=m_dLong1;
		m_dLong1=m_dLong2;
		m_dLong2=t;
	}
	if(m_dLat1>m_dLat2)
	{
		t=m_dLong1;
		m_dLat1=m_dLat2;
		m_dLat2=t;
	}

	//CString str;
	//str.Format(_T("Map %f,%f %f,%f"),m_dLong1,m_dLat1, m_dLong2,m_dLat2);
	//AfxMessageBox(str);
	return 1;
}


int CGpsMap::LoadBitmap(void)
{
//	cs = m_mapCurrent->m_sFilename;
	HDC hDCC = ::GetDC(NULL);
	LoadBitmapFile(hDCC , &m_hbmpMap, &m_sFilename);
	::ReleaseDC(NULL,hDCC);

	m_bmpMap.DeleteObject();
	m_bmpMap.Attach(m_hbmpMap);


	DIBSECTION ds;
	m_bmpMap.GetObject(sizeof (DIBSECTION), &ds);

	m_uWidth=ds.dsBm.bmWidth;
	m_uHeight=ds.dsBm.bmHeight;


	m_dXDegreePix = ((m_dLong2-m_dLong1)/(double)m_uWidth);
	m_dYDegreePix = ((m_dLat2-m_dLat1)/(double)m_uHeight);


	if(m_dXDegreePix<=0.0) m_dXDegreePix=1.0;	// prevent divide error
	if(m_dYDegreePix<=0.0) m_dYDegreePix=1.0;	// prevent divide error

	m_dZoom = 1.0;
	m_uX=0;
	m_uY=0;
	return 0;
}

void CGpsMap::ZoomMap(RECT* r)
{

	m_uZoomWidth = (UINT)((double)r->right*m_dZoom);
	m_uZoomHeight = (UINT)((double)r->bottom*m_dZoom);
	// calc size of screen in degrees
	m_dScrnLong = (double)m_uZoomWidth * m_dXDegreePix;
	m_dScrnLat = (double)m_uZoomHeight * m_dYDegreePix;
}

int CGpsMap::Pos2Screen(POINT * pnt, double lng, double lat)
{

	float fx = (lng-m_dLong1)/m_dXDegreePix;
	fx-=m_uX;
//	if(fx<0) fx=0;
//	if(fx>r.right)	fx=r.right;
	pnt->x=(fx/m_dZoom);

	float fy = m_uHeight;
		fy-=((lat-m_dLat1)/m_dYDegreePix);
	fy-=m_uY;
//	if(fy<0) fy=0;
//	if(fy>r.bottom)	fy=r.bottom;
	pnt->y=(fy/m_dZoom);	

	return 1;
}
