// GpsSetup.cpp : implementation file
//

#include "stdafx.h"
#include "embeddedgps.h"
#include "GpsSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGpsSetup dialog


CGpsSetup::CGpsSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CGpsSetup::IDD, pParent)
	, m_iAlt(FALSE)
	, m_ikmh(FALSE)
	, m_iutc(0)
	, m_iMaxDil(0)
{
	//{{AFX_DATA_INIT(CGpsSetup)
	m_strCom = _T("COM4:");
	m_strBaud = _T("9600");
	//}}AFX_DATA_INIT
}


void CGpsSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	if(!pDX->m_bSaveAndValidate)
	{
		m_strCom = theApp.m_sComName;
		m_strBaud.Format(_T("%d"),theApp.m_iBaudrate);
		m_iAlt = theApp.m_iKmlAlt;
		m_ikmh = theApp.m_iKmh;
		m_iutc = theApp.m_iutc;
		m_iMaxDil = theApp.m_iMaxDil;
	}
	//{{AFX_DATA_MAP(CGpsSetup)
	DDX_CBString(pDX, IDC_COMBO1, m_strCom);
	DDX_CBString(pDX, IDC_COMBO2, m_strBaud);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO1, ctrlCombo);
	DDX_Control(pDX, IDC_COMBO2, ctrlBaud);
	DDX_Radio(pDX, IDC_RADIO1, m_iAlt);
	DDX_Radio(pDX, IDC_RADIO3, m_ikmh);
	DDX_Text(pDX, IDC_EDIT1, m_iutc);
	DDV_MinMaxInt(pDX, m_iutc, -12, 12);
	if(pDX->m_bSaveAndValidate)
	{
		swscanf(LPCTSTR(m_strBaud),_T("%d"),&theApp.m_iBaudrate);
		theApp.m_sComName = m_strCom;
		theApp.m_iKmlAlt = m_iAlt;
		theApp.m_iKmh	  = m_ikmh;
		theApp.m_iutc	  = m_iutc;
		theApp.m_iMaxDil	  = m_iMaxDil;

	}
	DDX_Text(pDX, IDC_EDIT2, m_iMaxDil);
	DDV_MinMaxInt(pDX, m_iMaxDil, 15, 500);
}


BEGIN_MESSAGE_MAP(CGpsSetup, CDialog)
	//{{AFX_MSG_MAP(CGpsSetup)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO1, &CGpsSetup::OnCbnSelchangeCombo1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGpsSetup message handlers

void CGpsSetup::OnOK() 
{
	UpdateData();


	theApp.WriteProfileInt(_T("Settings"),REGVALUE_BAUD,theApp.m_iBaudrate);
	theApp.WriteProfileString(_T("Settings"),REGVALUE_COMPORT,theApp.m_sComName);
	theApp.WriteProfileInt(_T("Settings"),REGVALUE_KML_ALT,theApp.m_iKmlAlt);
	theApp.WriteProfileInt(_T("Settings"),REGVALUE_KMH,theApp.m_iKmh);
	theApp.WriteProfileInt(_T("Settings"),REGVALUE_UTC,theApp.m_iutc);
	theApp.WriteProfileInt(_T("Settings"),REGVALUE_MAXDIL,theApp.m_iMaxDil);
	theApp.m_fMaxDil=((double)m_iMaxDil/10.0);
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

//DEL BOOL CGpsSetup::OnInitDialog() 
//DEL {
//DEL 	CDialog::OnInitDialog();
//DEL 	m_strCom = "COM3";
//DEL 	m_strBaud = "9600";
//DEL 
//DEL 	(CGetDlgItem(IDC_COMBO1)->SetCurSel(2);
//DEL 	GetDlgItem(IDC_COMBO2)->SetCurSel(3);
//DEL 	// TODO: Add extra initialization here
//DEL 	
//DEL 	return TRUE;  // return TRUE unless you set the focus to a control
//DEL 	              // EXCEPTION: OCX Property Pages should return FALSE
//DEL }

BOOL CGpsSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
 //	(CGetDlgItem(IDC_COMBO1)->SetCurSel(2);
 //	GetDlgItem(IDC_COMBO2)->SelectString(m_strCom);

	ctrlCombo.AddString(_T("COM1:"));
	ctrlCombo.AddString(_T("COM2:"));
	ctrlCombo.AddString(_T("COM3:"));
	ctrlCombo.AddString(_T("COM4:"));
	ctrlCombo.AddString(_T("COM5:"));
	ctrlCombo.AddString(_T("COM6:"));
	ctrlCombo.AddString(_T("COM7:"));
	ctrlCombo.AddString(_T("COM8:"));

	ctrlBaud.AddString(_T("1200"));
	ctrlBaud.AddString(_T("2400"));
	ctrlBaud.AddString(_T("9600"));
	ctrlBaud.AddString(_T("14400"));
	ctrlBaud.AddString(_T("57600"));
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGpsSetup::OnCbnSelchangeCombo1()
{
	// TODO: Add your control notification handler code here
}
