/******************************Module*Header*******************************\
* Module Name: loadbmp.c
*
* Contains function that loads a bitmap file
*
* Created: 08-Jan-1992 11:06:37
* Author: Petrus Wong
*
* Copyright (c) 1990 Microsoft Corporation
*
* Contains the main routine for loading a DI bitmap file.
*
* Dependencies:
*
*   (#defines)
*   (#includes)
*       #include <windows.h>
*       #include "jtypes.h"
*
\**************************************************************************/

#include "stdafx.h"
#include "embeddedgps.h"
//#pragma hdrstop
//#include "prog32.h"
// #include "jtypes.h"
// #include <windows.h>

// extern HWND ghwndMain;
VOID ErrorOut(char errstring[30]);                   //extern
BOOL bSelectDIBPal(HDC, LPBITMAPINFO, BOOL);  //extern
// BOOL bFreeRleFile(PINFO);                            //extern
char str[128];

BOOL LoadBitmapFile(HDC hDC,  PSTR pszFileName);

// extern OPENEDFILE *CurFile;    pointer to current file data structure

/************************************************************************
 * void ErrorOut(char errstring[30])
 *
 * Purpose: Print out an meainful error code by means of
 *	  GetLastError and printf
 *
 * Inputs:  errstring - the action that failed, passed by the
 *		      calling proc.
 *
 * Returns: none
 *
 * Calls:   GetLastError
 *
 * History:
 * 09-13-91 Pete Grey   Created.
 *
\************************************************************************/


void ErrorOut(TCHAR *errstring)
{
DWORD Error;
//CString  str;
TCHAR str[128];

Error= GetLastError();
wsprintf(str, _T("Error on %s = %d\n"), errstring, Error);
AfxMessageBox(str,MB_OK,0); //_T("Map file not found!")ThrowArchiveException(CArchiveException::badIndex);

//MessageBox(hwndClient/*ghwndMain*/, (LPSTR)str, "Error", MB_OK);
}

/*
BOOL LoadBMPFile(HWND hwnd,CHAR *filename)
{
BOOL r;
//  if( !(CurFile=AddFileStruct(hwnd,filename)) )
 // {
//    SendMessage(hwnd,WM_CLOSE,0,0L);
//    return NULL;
//  }
HDC ghDC;
  ghDC=CreateDC("DISPLAY",NULL,NULL,NULL);   // handle to screen device
  if( ghDC != 0 )
  {
    CurFile->Type = FILETYPE_BMP;
    wsprintf(str,"Loading:%s  ",filename);
    SetWindowText(hwnd,str);

    r=LoadBitmapFile(hwnd,CurFile->ghDC, CurFile->Filename);

    SetWindowPos(CurFile->hwnd,HWND_TOP,0,0,CurFile->Xsize+10,CurFile->Ysize+10,
        SWP_NOMOVE);

    wsprintf(str,"Loaded:%s  ",CurFile->Filename);
    SetWindowText(hwnd,str);
  } else {
    SendMessage(hwnd,WM_CLOSE,0,0L);
    return NULL;
  }
  return r;
}

*/
/******************************Public*Routine******************************\
*
* bSelectDIBPal
*
* Effects: Creates a logical palette from the DIB and select it into the DC
*          and realize the palette. Saving the hPal in the pInfo->hPal
*
* Warnings: Based on Windows NT DIB support.  If PM support 16,24,32 bpp
*           we need to modify this routine.
*
* History:
*  22-Jan-1993      Petrus Wong         PM support
*  31-Dec-1992 -by- Petrus Wong
* Wrote it.
\**************************************************************************/

BOOL bSelectDIBPal(HDC hDC, LPBITMAPINFO pbmi, BOOL bCoreHdr)
{
  LOGPALETTE    *plogPal;
  UINT          uiSizPal;
  INT           i, iNumClr;
  WORD          wBitCount;

  if (bCoreHdr) {
    wBitCount = ((LPBITMAPCOREINFO)pbmi)->bmciHeader.bcBitCount;
  } else {
    wBitCount = pbmi->bmiHeader.biBitCount;
  }

  switch (wBitCount) {
    case 16:
    case 24:
    case 32:                            // Does PM supports these?
        return FALSE;
    default:
        iNumClr = (1 << wBitCount);
        break;
  }

  uiSizPal = sizeof(WORD)*2 + sizeof(PALETTEENTRY)*iNumClr;
  if ((plogPal = (LOGPALETTE *) LocalAlloc(LMEM_FIXED,uiSizPal)) == NULL) {
      ErrorOut(_T("Fail in Allocating palette!"));
 //     CurFile->hPalette = NULL;
      return FALSE;
  }

  plogPal->palVersion = 0x300;
  plogPal->palNumEntries = (WORD) iNumClr;
//  CurFile->NumColors=(WORD) iNumClr;        // set number of colors

  if (bCoreHdr) {
    for (i=0; i<iNumClr; i++) {
        plogPal->palPalEntry[i].peRed   = ((LPBITMAPCOREINFO)pbmi)->bmciColors[i].rgbtRed;
        plogPal->palPalEntry[i].peGreen = ((LPBITMAPCOREINFO)pbmi)->bmciColors[i].rgbtGreen;
        plogPal->palPalEntry[i].peBlue  = ((LPBITMAPCOREINFO)pbmi)->bmciColors[i].rgbtBlue;
        plogPal->palPalEntry[i].peFlags = PC_RESERVED;
    }
  } else {
    for (i=0; i<iNumClr; i++) {
        plogPal->palPalEntry[i].peRed   = pbmi->bmiColors[i].rgbRed;
        plogPal->palPalEntry[i].peGreen = pbmi->bmiColors[i].rgbGreen;
        plogPal->palPalEntry[i].peBlue  = pbmi->bmiColors[i].rgbBlue;
        plogPal->palPalEntry[i].peFlags = PC_RESERVED;
    }
  }

 // DeleteObject(CurFile->hPalette);
//  CurFile->hPalette = CreatePalette((LPLOGPALETTE)plogPal);
//  if ((CurFile->hPalette) == NULL) {
//      ErrorOut("Fail in creating palette!");
//      return FALSE;
//  }

//  if ((GetDeviceCaps(hDC, RASTERCAPS)) & RC_PALETTE) {
//    SelectPalette(hDC, (HPALETTE)CurFile->hPalette, FALSE);
//    RealizePalette(hDC);
//  }

  GlobalFree(plogPal);

  return TRUE;
}

/******************************Public*Routine******************************\
*
* LoadBitmapFile
*
* Effects:  Loads the bitmap from file and put into pInfo->hBmpSaved
*
* Warnings: pszFileName contains the full path
*
* History:
*  08-Feb-1993      Petrus Wong         Keep DIB around for HT
*  22-Jan-1993      Petrus Wong         16,24,32 PM
*  09-Jan-1992 -by- Petrus Wong
* Wrote it.
\**************************************************************************/

BOOL LoadBitmapFile(HDC hDC, HBITMAP *hBmpSaved, CString *file)
{
    BOOL            bSuccess;
    HANDLE          hFile, hMapFile;
    LPVOID          pMapFile;
    LPVOID          pPixelData;
    LPBITMAPINFOHEADER pbmh;
    LPBITMAPINFO    pbmi;
    PBYTE           pjTmp;
    ULONG           sizBMI;
    INT             iNumClr;
    BOOL            bCoreHdr;
    bSuccess = TRUE;

//HANDLE hBmpSaved,hBitmap,hPalette;
//  HDC   hdcmem;         // long lasting memory DC
//  HDC   ghDC;           // used by OpenGL child windows
//int Xsize,Ysize;
      //  ErrorOut(_T("Start"));

    if ((hFile = CreateFile(/*Ans->PictureF*/*file, GENERIC_READ, FILE_SHARE_READ, NULL,
            OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL)) == (HANDLE)-1) {
        ErrorOut(_T("Fail in file open"));
        bSuccess = FALSE;
        goto ErrExit1;
    }

    //
    // Create a map file of the opened file
    //
    if ((hMapFile = CreateFileMapping(hFile, NULL,
                             PAGE_READONLY, 0, 0, NULL)) == (HANDLE)-1) {
        ErrorOut(_T("Fail in creating map file"));
        bSuccess = FALSE;
        goto ErrExit2;

    }

    //
    // Map a view of the whole file
    //
    if ((pMapFile = MapViewOfFile(hMapFile, FILE_MAP_READ, 0, 0, 0)) == NULL) {
        ErrorOut(_T("Fail in mapping view of the Map File object"));
        bSuccess = FALSE;
        goto ErrExit3;
    }

    //
    // First check that it is a bitmap file
    //
    if (*((PWORD)pMapFile) != 0x4d42) {              // 'BM'
        ErrorOut(_T("This is not a DIB bitmap file!"));
        bSuccess = FALSE;
        goto ErrExit3;
    }

    //
    // The file header doesn't end on DWORD boundary...
    //
    pbmh = (LPBITMAPINFOHEADER)((PBYTE)pMapFile + sizeof(BITMAPFILEHEADER));

    {
        BITMAPCOREHEADER bmch, *pbmch;
        BITMAPINFOHEADER bmih, *pbmih;
        PBYTE            pjTmp;
        ULONG            ulSiz;

        pbmch = &bmch;
        pbmih = &bmih;

        pjTmp = (PBYTE)pbmh;
        ulSiz = sizeof(BITMAPCOREHEADER);
        memcpy(pbmch, pjTmp, ulSiz);

        pjTmp = (PBYTE)pbmh;
        ulSiz = sizeof(BITMAPINFOHEADER);
         memcpy(pbmih, pjTmp, ulSiz);

        //
        // Use the size to determine if it is a BitmapCoreHeader or
        // BitmapInfoHeader
        //
        // Does PM supports 16 and 32 bpp? How?
        //
        if (bmch.bcSize == sizeof(BITMAPCOREHEADER))
        {
            WORD wBitCount;

            wBitCount = bmch.bcBitCount;
            iNumClr = ((wBitCount == 24) ? 0 : (1 << wBitCount));
            sizBMI = sizeof(BITMAPCOREHEADER)+sizeof(RGBTRIPLE)*iNumClr;
            bCoreHdr = TRUE;
        }
        else            // BITMAPINFOHEADER
        {
            WORD wBitCount;

            wBitCount = bmih.biBitCount;
            switch (wBitCount) {
                case 16:
                case 32:
                    sizBMI = sizeof(BITMAPINFOHEADER)+sizeof(DWORD)*3;
                    break;
                case 24:
                    sizBMI = sizeof(BITMAPINFOHEADER);
                    break;
                default:
                    iNumClr = (1 << wBitCount);
                    sizBMI = sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*iNumClr;
                    break;
            }
            bCoreHdr = FALSE;
        }

    }

    if ((pbmi = (LPBITMAPINFO) LocalAlloc(LMEM_FIXED,sizBMI)) == NULL) {
        ErrorOut(_T("Fail in Memory Allocation!"));
        bSuccess = FALSE;
        goto ErrExit3;
    }

    //
    // Make sure we pass in a DWORD aligned BitmapInfo to CreateDIBitmap
    // Otherwise, exception on the MIPS platform
    // CR!!!  Equivalent to memcpy
    //
    pjTmp = (PBYTE)pbmi;

    memcpy(pjTmp,pbmh,  sizBMI);

    //
    // assuming CreateDIBitmap() is doing a byte fetch...
    //
    pMapFile = (PBYTE)pMapFile + ((BITMAPFILEHEADER *)pMapFile)->bfOffBits;

    //
    // Select the palette into the DC first before CreateDIBitmap()
    //CreateBitmap
    bSelectDIBPal(hDC, pbmi, bCoreHdr);
 //   if ((*hBmpSaved = CreateDIBitmap(hDC, (LPBITMAPINFOHEADER)pbmi,
 //                       CBM_INIT, pMapFile, pbmi, DIB_RGB_COLORS)) == NULL) {
    if ((*hBmpSaved = CreateDIBSection(hDC, (LPBITMAPINFO)pbmi,
                        DIB_RGB_COLORS, &pPixelData, NULL,NULL)) == NULL) {
        ErrorOut(_T("Fail in creating DIB bitmap from file!"));
        bSuccess = FALSE;
        goto ErrExit4;
    }
	 memcpy(pPixelData, pMapFile, (pbmi->bmiHeader.biWidth*pbmi->bmiHeader.biHeight));

/*    Ans->Xsize=(int)pbmi->bmiHeader.biWidth;
    Ans->Ysize=(int)pbmi->bmiHeader.biHeight;
    if(Ans->Xsize<0) Ans->Xsize=-Ans->Xsize;
    if(Ans->Ysize<0) Ans->Ysize=-Ans->Ysize;
*/
    //
    // Saving the DIB...free memory when the windows is closed.
    //
 //   CurFile->rgpjFrame = (unsigned char *)pMapFile;
 //   CurFile->rgpbmi    = pbmi;
//    CurFile->pbmi         = (PBITMAPINFO) &(CurFile->rgpbmi);

/*
  Ans->ghDC=CreateDC("DISPLAY",NULL,NULL,NULL);   // handle to screen device
  hDCC = GetDC(NULL);
  //  hMemDC = CreateCompatibleDC(hDCC);   // release at WM_DESTROY

  Ans->hdcmem=CreateCompatibleDC(hDCC);       // create a memory handle
  ReleaseDC(NULL,hDCC);
	//	CurFile->hdcmem = CreateCompatibleDC(hDC);

*/
    // set flag to use original DIB as source for blting so HT can be done
//    CurFile->bUseDIB = TRUE;
 //   CurFile->bCoreHdr = bCoreHdr;
 //  return (bSuccess);

ErrExit4:
    LocalFree(pbmi);
ErrExit3:
    CloseHandle(hMapFile);
ErrExit2:
    CloseHandle(hFile);
ErrExit1:

    return (bSuccess);

}



