// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "embeddedgps.h"
#include "GpsSetup.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define TOOLBAR_HEIGHT 24

const DWORD dwAdornmentFlags = 0; // exit button

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_TIMER()
	ON_COMMAND(ID_SETUP, OnGpsSetup)
	ON_COMMAND(ID_STARTLOG, OnStartlog)
	ON_COMMAND(ID_ENDLOG, OnEndlog)
	ON_UPDATE_COMMAND_UI(ID_STARTLOG, OnUpdateStartlog)
	ON_UPDATE_COMMAND_UI(ID_ENDLOG, OnUpdateEndlog)
	ON_COMMAND(ID_PLACEMARK, OnPlacemark)
	ON_UPDATE_COMMAND_UI(ID_PLACEMARK, OnUpdatePlacemark)
	ON_COMMAND(IDM_GPSDATA, OnGpsdata)
	ON_COMMAND(IDM_GPSSTATUS, OnGpsstatus)
	ON_COMMAND(IDM_KOMPASS, OnKompass)
	ON_COMMAND(IDM_SHOWTRACK, OnShowtrack)
	ON_UPDATE_COMMAND_UI(IDM_GPSDATA, OnUpdateGpsdata)
	ON_UPDATE_COMMAND_UI(IDM_GPSSTATUS, OnUpdateGpsstatus)
	ON_UPDATE_COMMAND_UI(IDM_KOMPASS, OnUpdateKompass)
	ON_UPDATE_COMMAND_UI(IDM_SHOWTRACK, OnUpdateShowtrack)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_COMMAND(IDM_SHOW_MAP, OnShowMap)
	ON_COMMAND(ID_TOOLS_LOADMAP, &CMainFrame::OnToolsLoadmap)
END_MESSAGE_MAP()
//	ON_COMMAND(ID_APP_EXIT, OnExit)


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bChanged = FALSE;
	m_iBrightness = 0;
//	m_mapCurrent=NULL;
	m_bEnabled = TRUE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	if (!m_wndCommandBar.Create(this) ||
	    !m_wndCommandBar.InsertMenuBar(IDR_MAINFRAME) ||
	    !m_wndCommandBar.AddAdornments(dwAdornmentFlags))
	{
		TRACE0("Failed to create CommandBar\n");
		return -1;      // fail to create
	}

	m_wndCommandBar.SetBarStyle(m_wndCommandBar.GetBarStyle() | CBRS_SIZE_FIXED);

	m_hLcd=NULL;
	SetTimer(1234,1000,NULL);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs))
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs


	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
LPTSTR CMainFrame::MakeString(UINT stringID)
{
	TCHAR buffer[255];
	TCHAR* theString;

	::LoadString(AfxGetInstanceHandle(), stringID, buffer, 255);
	theString = new TCHAR[lstrlen(buffer) + 1];
	lstrcpy(theString, buffer);
	return theString;
}   



// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}
#endif //_DEBUG

// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}



/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnTimer(UINT nIDEvent) 
{
static bool inf=false;
	if(nIDEvent==1234 && !inf)
	{
		inf=true;							// don't do this twice
		SystemIdleTimerReset();			// keep device awake

	SYSTEM_POWER_STATUS_EX PowerStatus;
		GetSystemPowerStatusEx(&PowerStatus,FALSE);
		if(PowerStatus.ACLineStatus!=1 && m_iBrightness && m_iBrightnessTime==1) 
		{
	/*		SetLowBrightness();
			SetHighBrightness();

	The first step is to query the device for the supported brightness using the 
	IOCTL_VIDEO_QUERY_SUPPORTED_BRIGHTNESS control code. 
	This operation returns a buffer that specifies the available brightness levels. 
	Next, you can query the device for the current display brightness using the 
	IOCTL_VIDEO_QUERY_DISPLAY_BRIGHTNESS control code.
	 This operation returns the current settings for alternating current (AC) brightness, 
	 direct current (DC) brightness, and the power state.

	To change the display brightness, use the IOCTL_VIDEO_SET_DISPLAY_BRIGHTNESS control 
	code. You can set the AC brightness, the DC brightness, or both.


			HIGHCONTRAST hc;
			hc.cbSize = sizeof(HIGHCONTRAST);
			SystemParametersInfo(SPI_SETHIGHCONTRAST, sizeof(HIGHCONTRAST), &hc, FALSE);
	*/		
		}

		/*
HIGHCONTRAST hc;
	hc.cbSize=sizeof(HIGHCONTRAST);
BOOL GetSystemPowerStatusEx(
PSYSTEM_POWER_STATUS_EX pstatus, 
BOOL fUpdate
);

DWORD GetSystemPowerStatusEx2(
PSYSTEM_POWER_STATUS_EX2 pSystemPowerStatusEx2,
DWORD dwLen, 
BOOL fUpdate

BOOL SystemParametersInfo( 
UINT uiAction, SPI_SETHIGHCONTRAST
UINT uiParam,	sizeof(HIGHCONTRAST)
PVOID pvParam, NULL
UINT fWinIni	FALSE
);
		*/

		CGpsFrame *dat = &theApp.m_GpsData;
		dat->ReadGpsData();				// read data from comport

//		dat->Longitude = 52.3858333;
//		dat->Latitude = 4.6263889;

//		dat->Latitude = 12.1663889;
//		dat->Longitude = -68.2463889;
		
		if(m_bEnabled && (dat->FillFlags & (GFF_LATITUDE|GFF_LONGITUDE)) == (GFF_LATITUDE|GFF_LONGITUDE) ) // valid data?
		{
			float dir = (float)fabs(dat->LastStoredDirection-dat->Direction);
			if((int)dat->m_SecCounter>(dat->Speed>60.0?10:dat->Speed>40.0?20:dat->Speed>20.0?40:60) || 
				(dat->Speed>1.0 && dir>2.0) ) // log when direction changed
			{
				dat->StoreFrame();
				m_bChanged = TRUE;
			}
			m_wndView.PositionMap();
			m_wndView.Invalidate(theApp.m_iViewType==3?TRUE:FALSE); // clear track
		} else 
			if(theApp.m_iViewType==1)
				m_wndView.Invalidate(FALSE); // update time
		inf=false;
	} else
		CFrameWnd::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnGpsSetup() 
{

	CGpsSetup dlg;
	//dlg.m_strCom = theApp.m_sComName;
	//dlg.m_strBaud.Format(_T("%d"),theApp.m_iBaudrate);

	if(dlg.DoModal()==IDCANCEL)
		return ;
	//swscanf(LPCTSTR(dlg.m_strBaud),_T("%d"),&theApp.m_iBaudrate);
	//theApp.m_sComName = dlg.m_strCom;

	while(!theApp.m_GpsData.Connect(theApp.m_sComName,theApp.m_iBaudrate))
	{
		AfxMessageBox(_T("GPS not found!\n Please select correct port and baudrate."),MB_OK,NULL);
		if(dlg.DoModal()!=IDOK)
			return ;
		//swscanf(LPCTSTR(dlg.m_strBaud),_T("%d"),&theApp.m_iBaudrate);
		//theApp.m_sComName = dlg.m_strCom;
	}

	
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnStartlog() 
{
	theApp.m_GpsData.StartLog();
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnEndlog() 
{
	theApp.m_GpsData.EndLog();
}


/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateStartlog(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(theApp.m_GpsData.m_hLog==NULL);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateEndlog(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(theApp.m_GpsData.m_hLog!=NULL);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnPlacemark() 
{
	theApp.m_GpsData.LogPlaceMark(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdatePlacemark(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(theApp.m_GpsData.m_hLog!=NULL);
	
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnGpsdata() 
{
	theApp.m_iViewType = 1;
	m_wndView.Invalidate(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnGpsstatus() 
{
	theApp.m_iViewType = 4;
	m_wndView.Invalidate(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnKompass() 
{
	theApp.m_iViewType = 2;
	m_wndView.Invalidate(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnShowtrack() 
{
	theApp.m_iViewType = 3;
	m_wndView.Invalidate(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateGpsdata(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(theApp.m_iViewType==1);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateGpsstatus(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(theApp.m_iViewType==4);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateKompass(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(theApp.m_iViewType==2);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateShowtrack(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(theApp.m_iViewType==3);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE); //theApp.m_lstPoints.GetCount()>0);
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnFileOpen() 
{
	CString filename;
	CFileDialog fdlg(TRUE,_T(".gpd"),NULL,OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
		_T("GPS trackdata (*.gpd)|*.gpd||"),this);
	if(!fdlg.DoModal())
		return;

	//	filename = fdlg.m_ofn.lpstrInitialDir;
	filename = fdlg.m_ofn.lpstrFile;

	CFile file;
	CString str,name;
	int i;
	char buf[256];
	if(!file.Open(filename, CFile::modeRead)) 
	{
		AfxMessageBox(filename);
		return ;
	}
	file.Read(buf,6+sizeof(int));
	if(buf[5]!=0x1A)
	{
		AfxMessageBox(_T("Incorrect file"));
		return ;
	}
	CArchive ar( &file, CArchive::load, 256, buf );
	CGpsPoint *pnt;
	i=0;
	while(file.GetPosition()<file.GetLength())
	{
		i++;
		pnt = new CGpsPoint;
//		pnt->Serialize(ar);
		file.Read(&pnt->m_fLat,sizeof(float));
		file.Read(&pnt->m_fLong,sizeof(float));
		file.Read(&pnt->m_fSpeed,sizeof(float));
		file.Read(&pnt->m_fAltitude,sizeof(float));
		file.Read(&pnt->m_fDirection,sizeof(float));
		file.Read(&pnt->m_fDilution,sizeof(float));
		file.Read(&pnt->hour,sizeof(char));
		file.Read(&pnt->min,sizeof(char));
		file.Read(&pnt->second,sizeof(char));
		pnt->m_strComment.Empty();
		do
		{
			file.Read(buf,1);
			if(*buf)
				pnt->m_strComment += buf[0];
		} while(*buf); //file.Write(pnt->m_strComment.GetBuffer(256),pnt->m_strComment.GetLength()+1);
//		CString str;
//		str.Format(_T("%.2f %.2f %s"),pnt->m_fLat,pnt->m_fLong,pnt->m_strComment);
//		AfxMessageBox(str);

	
		theApp.m_lstPoints.AddTail(pnt);
	}
	file.Close();
	OnShowtrack();
}

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnFileSave() 
{
	CString filename;
	CFileDialog fdlg(FALSE,_T(".gpd"),NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		_T("GPS trackdata (*.gpd)|*.gpd|Google track (*.kml)|*.kml||"),this);
	if(fdlg.DoModal())
	{
//		filename = fdlg.m_ofn.lpstrInitialDir;
		filename = fdlg.m_ofn.lpstrFile;


		if(filename.Find(_T(".kml"),0)>0)
		{
			theApp.SaveKml(&filename);
			return;

		}

		CString str;
		HANDLE hf = CreateFile( fdlg.m_ofn.lpstrFile, //_T("LogFile.txt"),
			 GENERIC_READ | GENERIC_WRITE,
			 0,    // comm devices must be opened w/exclusive-access 
			 NULL, // no security attributes 
			 CREATE_ALWAYS, //OPEN_EXISTING, // comm devices must use OPEN_EXISTING 
			 FILE_ATTRIBUTE_NORMAL,    // not overlapped I/O 
			NULL  // hTemplate must be NULL for comm devices 
			);
		if (hf == INVALID_HANDLE_VALUE) 
		{
			hf=NULL;
			str = _T("Error opening:");
			str += fdlg.m_ofn.lpstrFile;
			AfxMessageBox(str,MB_OK|MB_SETFOREGROUND);
			return;
		}
		CFile file(hf);//(HFILE)
	/*	if(!file.Open(fdlg.m_ofn.lpstrFile, CFile::modeCreate || CFile::modeWrite), NULL) 
	*/
		POSITION pos;
		CGpsPoint *pnt;

		//if(filename.Find(_T(".kml"),0)>0)
		//{
		//	CString s;
		//	s = "<?xml version=\x22\x31.0\x22 encoding=\x22UTF-8\x22?><kml xmlns=\x22http://earth.google.com/kml/2.1\x22>\n";
		//	s += "<Document>\n<name>";
		//	s+=filename;
		//	s+="</name>\n";
		//	WriteString( &s,hf); 
		//	s = "<description>GpsTrack collected with PocketGps on mobile. </description>\n<Style id=\x22yellowLineGreenPoly\x22>";
		//	s += "<LineStyle><color>7f00ffff</color><width>4</width></LineStyle>";
		//	s += "<PolyStyle><color>7f00ff00</color></PolyStyle></Style>\n";
		//	WriteString( &s,hf); 

		//	// start track
		//	s = "<Placemark><name>Track1</name><description> </description><styleUrl>#yellowLineGreenPoly</styleUrl>\n";
		//	s += "<LineString><extrude>1</extrude><tessellate>1</tessellate><altitudeMode>absolute</altitudeMode>\n";
		//	s += "<coordinates>\n";
		//	WriteString( &s,hf); 

		//	pos = theApp.m_lstPoints.GetHeadPosition();
		//	while(pos!=NULL)
		//	{
		//		pnt = theApp.m_lstPoints.GetNext(pos);
		//		//	s.Format(_T("%f,%f,%f\n"), pnt->m_fLong, pnt->m_fLat, pnt->m_fAltitude);
		//		s.Format(_T("%f,%f,%f\n"), pnt->m_fLong, pnt->m_fLat, pnt->m_fSpeed*10.0);
		//		WriteString( &s,hf);
		//	}
		//	s = "</coordinates></LineString></Placemark>";
		//	WriteString(&s,hf); 
		//	 
		////	Log placemarks and time marks
		//	pos = theApp.m_lstPoints.GetHeadPosition();
		//	UCHAR lasthour=25;
		//	CString desc;
		//	while(pos!=NULL)
		//	{
		//		pnt = theApp.m_lstPoints.GetNext(pos);
		//		if(pnt->m_strComment.GetLength() || pnt->hour!=lasthour)
		//		{
		//			if(pnt->hour!=lasthour) lasthour = pnt->hour;
		//			s.Format(_T("<Placemark><name>%s %d:%02d</name>\n"),
		//				pnt->m_strComment.GetBuffer(256),pnt->hour,pnt->min, desc);
		//			desc.Format(_T("<description>%d:%02d %s  Speed:%f knots = %f kmh</description>\n"),pnt->hour,pnt->min,pnt->m_strComment.GetBuffer(256),
		//				pnt->m_fSpeed,pnt->m_fSpeed*KNTS2KMH); 
		//			s+=desc;
		//			WriteString(&s,hf); 
		//			s.Format(_T("<LookAt><longitude>%f</longitude><latitude>%f</latitude><altitude>%f</altitude>\n"),
		//			 pnt->m_fLong,pnt->m_fLat,pnt->m_fAltitude );
		//			s+=_T("<range>1000.00</range><tilt>66.66</tilt>\n");
		//			s+=_T("<heading>5.164</heading></LookAt><styleUrl>#msn_ylw-pushpin_copy1</styleUrl>\n");
		//			WriteString(&s,hf); 
		//			s.Format(_T("<Point><coordinates>%f,%f,0</coordinates></Point></Placemark>"),pnt->m_fLong, pnt->m_fLat);
		//			WriteString(&s,hf); 
		//		}
		//	}
		//	s = _T("</Document></kml>\n");
		//	WriteString(&s,hf);  


		//} else {

			char chbuf[7] = "GPD\x0D\x0A\x1A";
			file.Write(chbuf,6);
			UINT i=theApp.m_lstPoints.GetCount();
			file.Write(&i,sizeof(UINT));
			pos = theApp.m_lstPoints.GetHeadPosition();
			while(pos!=NULL)
			{
				pnt = theApp.m_lstPoints.GetNext(pos);
				pnt->Write(hf);
			}
	//	}
		file.Close();
		m_bChanged = FALSE;
	} 
}


/////////////////////////////////////////////////////////////////////////////
void CMainFrame::WriteString(CString *str,HANDLE hf)
{
static BOOL errshown=FALSE;
DWORD num;
	char ch;
	if(hf!=NULL)
	{
		for(int u=0;u<str->GetLength();u++)
		{
			ch = (char)str->GetAt(u);
			WriteFile(hf, &ch, 1,&num,NULL);
			if(num!=1)
			{
				if(!errshown)
				{
					errshown=TRUE;
					AfxMessageBox(_T("Error writing file"),MB_OK|MB_SETFOREGROUND);
				}
				return;
			}
		}
		errshown=FALSE;	// reset after succesfull write
	}
}

BOOL LoadBitmapFile(HDC hDC, HBITMAP *hBmpSaved, CString *file);

//extern double MapX1,MapX2,MapY1,MapY2;

/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnShowMap() 
{
	// LoadMapDialog
	// Set Zoom & pos
	CString cs;
	//CFileDialog fdlg(TRUE,NULL,NULL,OFN_HIDEREADONLY,
	//	_T("Bitmap (*.bmp)|*.bmp||"),this);

	//if(fdlg.DoModal()!=IDOK)
	//	return;

	////		filename = fdlg.m_ofn.lpstrInitialDir;
	//cs = fdlg.m_ofn.lpstrFile;

	if(m_wndView.m_mapCurrent==NULL)
	{
		AfxMessageBox(_T("Eerst map inlezen! Tools, Load map"),MB_OK);
		return;
	}
/*
	cs = m_mapCurrent->m_sFilename;
	HDC hDCC = ::GetDC(NULL);
	LoadBitmapFile(hDCC , &m_mapCurrent->m_hbmpMap, &cs);
	::ReleaseDC(NULL,hDCC);

	m_mapCurrent->m_bmpMap.DeleteObject();
	m_mapCurrent->m_bmpMap.Attach(m_mapCurrent->m_hbmpMap);

int a,b,c,d,am,bm,cm,dm;
CString cx; 
	cx = cs.Right(cs.GetLength()-cs.Find('X'));

	swscanf(LPCTSTR(cx),_T("X%dG%dM_%dG%dMY%dG%dM_%dG%dM"),&a,&am,&b,&bm,&c,&cm,&d,&dm);

	cs.Format(_T("X%dG%dM_%dG%dMY%dG%dM_%dG%dM"),a,am,b,bm,c,cm,d,dm);

	m_mapCurrent->MapX1 = (double)a + ((double)am/60.0); //4G22M
	m_mapCurrent->MapX2 = (double)b + ((double)bm/60.0); //4G30M
	m_mapCurrent->MapY1 = (double)c + ((double)cm/60.0);	//52G19M
	m_mapCurrent->MapY2 = (double)d + ((double)dm/60.0); //52G31M
*/
//	CString cs;
//	cs.Format(_T("X1:%.2f X2:%.2f  Y1:%2.f Y2:%2f"),MapX1,MapX2,MapY1,MapY2);
/*
	AfxMessageBox(cs,MB_OK,0); //_T("Map file not found!")ThrowArchiveException(CArchiveException::badIndex);

*/

// IDB_BITMAP2
/*
	MapX1 = 3.8333333; //3G50M
	MapX2 = 4.1166667; //4G7M
	MapY1 = 51.8;		//51G48M
	MapY2 = 52.0166667; //52G1M
	m_bmpMap.LoadBitmap(IDB_BITMAP2);
	MapX1 = 3.9666667; //3G58M
	MapX2 = 4.2833333; //4G17M
	MapY1 = 51.9666667;		//51G58M
	MapY2 = 52.2; //52G12M
	m_bmpMap.LoadBitmap(IDB_BITMAP3);
	MapX1 = 4.15; //4G9M
	MapX2 = 4.45; //4G27M
	MapY1 = 52.0833333;		//52G5M
	MapY2 = 52.25; //52G15M
	m_bmpMap.LoadBitmap(IDB_BITMAP4);

	MapX1 = 4.2333333; //4G14M
	MapX2 = 4.5333333; //4G32M
	MapY1 = 52.2333333;		//52G14M
	MapY2 = 52.45; //52G27M
	m_bmpMap.LoadBitmap(IDB_BITMAP5);
*/

/*
	MapX1 = 4.3666667; //4G22M
	MapX2 = 4.6666667; //4G40M
	MapY1 = 52.3166667;		//52G19M
	MapY2 = 52.5166667; //52G31M
	m_bmpMap.LoadBitmap(IDB_BITMAP6);
*/
	theApp.m_iViewType = 5;
	m_wndView.Invalidate(TRUE);

//	CString cs = _T("\\storage card\\program files\\gpstrack\\X3G50M_4G7MY51G48M_52G2M.bmp"); //((CInfoViewDoc *)GetDocument())->m_strPictureFile;

/*

	HBITMAP hbmp = m_bmpMap;
	if(hbmp!=NULL) //bmpBackGround.m_hObject)
	{
		int TODO_ReloadBackgroundCorrect;

		m_bmpMap.Detach();
		m_bmpMap.DeleteObject();
//		bmpBackGround.m_hObject=NULL;
	}

	if(cs.GetLength())
	{
		HBITMAP hBitmap = (HBITMAP) ::LoadImage (AfxGetInstanceHandle (),
				(LPCTSTR)cs/ *.GetBuffer(cs.GetLength()+1)* /,// "background.bmp", 
				IMAGE_BITMAP, 0, 0,0);// LR_LOADFROMFILE | LR_CREATEDIBSECTION);
		if (hBitmap == NULL) {
			AfxMessageBox(cs,MB_OK,0); //_T("Map file not found!")ThrowArchiveException(CArchiveException::badIndex);
		} else
			m_bmpMap.Attach(hBitmap);
	}
*/
}


//void CMainFrame::OnExit(void)
//{
//	OnEndlog();
//	CWinApp::OnAppExit();
//}

void CMainFrame::OnToolsLoadmap()
{
	CString cs;
	CGpsMap *map,*smalmap;

	smalmap=theApp.FindMap();//NULL;
	//if( (theApp.m_GpsData.FillFlags & (GFF_LATITUDE|GFF_LONGITUDE)) == (GFF_LATITUDE|GFF_LONGITUDE) ) // valid data?
	//{

	//	// check maplist with current position.
	//	// load smallest file

	//	POSITION pos = theApp.m_lstMaps.GetHeadPosition();
	//	double x,y;
	//	x=theApp.m_GpsData.Longitude;
	//	y=theApp.m_GpsData.Latitude;
	//	while(pos)
	//	{
	//		map = theApp.m_lstMaps.GetNext(pos);
	//		if(x>map->m_dLong1 && x<map->m_dLong2 && y>map->m_dLat1 && y<map->m_dLat2 &&
	//			(smalmap==NULL ||	(map->m_dLong2-map->m_dLong1) < (smalmap->m_dLong2-smalmap->m_dLong1)) )
	//		{
	//			smalmap = map;	// track smallest map
	//		}
	//	}
	//}

	if(smalmap==NULL)
	{

		CFileDialog fdlg(TRUE,NULL,NULL,OFN_HIDEREADONLY,
			_T("Bitmap (*.bmp)|*.bmp||"),this);

		if(fdlg.DoModal()!=IDOK)
			return;

		map = new CGpsMap;
		map->m_sFilename = fdlg.m_ofn.lpstrFile;//finder.GetFileName();
		theApp.m_lstMaps.AddTail(map);
		if(!map->GetFilenamePosition())
			AfxMessageBox(_T("Weet niet waar dat is!"),MB_OK);

		m_wndView.m_mapCurrent = map; //smallest map (allways use most zoomed pict on gps pos)
		map->m_uX=0;
		map->m_uY=0;

	} else {
	//	cs = _T("Selected: ");
	//	cs += smalmap->m_sFilename;
	//	AfxMessageBox(cs,MB_OK);
		m_wndView.m_mapCurrent = smalmap; //smallest map (allways use most zoomed pict on gps pos)
	}

	SetCursor(::LoadCursor(NULL, IDC_WAIT));
	m_wndView.m_mapCurrent->LoadBitmap();
	SetCursor(::LoadCursor(NULL, IDC_ARROW));

//	m_wndView.m_mapCurrent->m_dZoom=1.0;
		//	RECT r;
		//	GetClientRect(&r);
			RECT r;
			m_wndView.GetClientRect(&r);
			r.bottom-=14;
			m_wndView.m_mapCurrent->ZoomMap(&r);

//	m_wndView.m_mapCurrent->m_uZoomWidth = (UINT)((double)r.right*m_wndView.m_mapCurrent->m_dZoom);
//	m_wndView.m_mapCurrent->m_uZoomHeight = (UINT)((double)r.bottom*m_wndView.m_mapCurrent->m_dZoom);

	theApp.m_iViewType = 5;
	m_wndView.Invalidate(TRUE);

}
