// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "ChildView.h"

#define NUM_TOOL_TIPS 8



class CMainFrame : public CFrameWnd
{
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

public:
	CMenu m_mnu;
	BOOL m_bChanged;
	int m_iBrightness;
	int m_iLowBrightness;
	int m_iHighBrightness;
	int m_iBrightnessTime;
	UCHAR m_pBrightnessLevels[256];
	HANDLE m_hLcd;
	BOOL	m_bEnabled;

	//CBitmap	m_bmpMap;
	//HBITMAP	m_hbmpMap;
	//float		m_fX1,m_fY1,m_fX2,m_fY2;	// map position
	//UINT		m_uScale;		// map scale
	//UINT		m_uX,m_uY;		// map start (TopLeft)
	//UINT		m_uPosX,m_uPosY;	// current position on map

//	CGpsMap	*m_mapCurrent;

	LPTSTR m_ToolTipsTable[NUM_TOOL_TIPS]; 

// Operations
public:
	LPTSTR MakeString(UINT stringID);

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

// Implementation
public:
	void WriteString(CString *str,HANDLE hf);
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
#endif
	CChildView    m_wndView;

protected:  // control bar embedded members
	CCommandBar m_wndCommandBar;

	CGpsPointList	m_lstPoints;	// the track data
// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGpsSetup();
	afx_msg void OnStartlog();
	afx_msg void OnEndlog();
	afx_msg void OnUpdateStartlog(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEndlog(CCmdUI* pCmdUI);
	afx_msg void OnPlacemark();
	afx_msg void OnUpdatePlacemark(CCmdUI* pCmdUI);
	afx_msg void OnGpsdata();
	afx_msg void OnGpsstatus();
	afx_msg void OnKompass();
	afx_msg void OnShowtrack();
	afx_msg void OnUpdateGpsdata(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGpsstatus(CCmdUI* pCmdUI);
	afx_msg void OnUpdateKompass(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShowtrack(CCmdUI* pCmdUI);
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnShowMap();
//	afx_msg void OnExit(void);
	
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnToolsLoadmap();
};


