// Registry.cpp: implementation of the CRegistry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Registry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRegistry::CRegistry(HKEY mainkey, TCHAR *sRegKey)
{
/*
	CString sRegKey;			// Open registry key
	sRegKey = REG_SUBKEY;
	sRegKey += REG_COMPANYNAME;
	sRegKey += REG_PRODUCTNAME;
	sRegKey += REG_PRODUCTVERSION;
	sRegKey += REG_SETTINGS;
*/
	DWORD disposition=0;
	if (RegCreateKeyEx(mainkey, LPCTSTR(sRegKey), 0, NULL, REG_OPTION_NON_VOLATILE,
			 KEY_ALL_ACCESS, NULL, &m_hRegistryKey, &disposition) != ERROR_SUCCESS)
	{
		disposition = REG_CREATED_NEW_KEY;
		m_hRegistryKey = NULL;
		AfxMessageBox(_T("Kan de registry data niet openen!"),MB_OK,NULL); 
		// we could not create a key in the registry!!...
	}
}

CRegistry::~CRegistry()
{
	::CloseHandle(m_hRegistryKey);
}



/////////////////////////////////////////////////////////////////////////////
// 
int CRegistry::GetInt(TCHAR *szName, int def)
{
unsigned long ret,l,type;
type = REG_DWORD;
	l=sizeof(DWORD);
	if (RegQueryValueEx(m_hRegistryKey, szName, 0, &type, (unsigned char *)&ret, &l) != ERROR_SUCCESS)
		ret = def;
	return (int)ret;
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CRegistry::SetInt(TCHAR *szName, int def)
{
unsigned long l,type = REG_DWORD;
	l = sizeof(int);
	return  (RegSetValueEx(m_hRegistryKey, szName, 0, type, (byte *)&def, l) == ERROR_SUCCESS);
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CRegistry::GetString(CString *dest, TCHAR *szName, TCHAR *def)
{
TCHAR defaulttext[] = _T("");
CString cszRet;
TCHAR ts[MAX_PATH];
unsigned long type = REG_SZ;
DWORD l=MAX_PATH;
BOOL ret = TRUE;
	if(!def) def=defaulttext;

	cszRet = def;

	if (RegQueryValueEx(m_hRegistryKey, szName, 0, &type, (unsigned char *)ts, &l) != ERROR_SUCCESS) {
		cszRet = def;
		ret =FALSE;
	} else
		cszRet = ts;
	*dest = cszRet;
	return ret; //cszRet;
}

/////////////////////////////////////////////////////////////////////////////
// 
int CRegistry::SetString(TCHAR *szName, TCHAR *szData)
{
unsigned long type = REG_SZ;
	return (RegSetValueEx(m_hRegistryKey, szName, 0, type, (byte *)szData, wcslen(szData)+1) == ERROR_SUCCESS);
}


/////////////////////////////////////////////////////////////////////////////
// 
//DEL int CRegistry::SetRegistryDate(TCHAR *szName, CTime *pDate)
//DEL {
//DEL CString strDate = pDate->Format("%d %m %Y");
//DEL 	return SetString(szName,strDate.GetBuffer(strDate.GetLength()));
//DEL }

/////////////////////////////////////////////////////////////////////////////
// 
CTime CRegistry::GetRegistryDate(TCHAR *szName, CTime *def)
{
CString strDate;
CTime now;
int d=1,m=1,y=2007;
	if(GetString(&strDate,szName,NULL))
	{
		if(swscanf(strDate.GetBuffer(strDate.GetLength()),_T("%d %d %d"),&d,&m,&y)==EOF)
		{
			if(def)
			{
				d=def->GetDay();
				m=def->GetMonth();
				y=def->GetYear();
			}
		}
//		delete strDate;
		now = CTime(y,m,d,1,1,1);
	} else
		if(def)
			now = *def;
	return now;
}

/*
/////////////////////////////////////////////////////////////////////////////
BOOL CSynchronize::RegistryLoad(HKEY hModelKey, CString *sSubKey)
{
unsigned long l;
BOOL ret=FALSE;
BYTE* buf;
	l=4096;
	buf = (BYTE*)::calloc(l, sizeof(BYTE));
ULONG type;

	if (RegQueryValueEx(hModelKey, LPCTSTR(*sSubKey), 0, &type, buf, &l) == ERROR_SUCCESS) 
	{
		CMemFile mFile(buf,l);
		CArchive arch(&mFile,CArchive::load);
		arch.m_bForceFlat = FALSE;
		Serialize(arch);
		arch.Close();
		mFile.Close();
		ret=TRUE;
	}
	free(buf);
	return ret;
}


/////////////////////////////////////////////////////////////////////////////
BOOL CSynchronize::RegistryStore(HKEY hModelKey, CString *sSubKey)
{
unsigned long l,type = REG_BINARY;
BOOL ret=FALSE;
BYTE* buf;

	l = sizeof(CSynchronize);
	l += From.GetLength() + To.GetLength() + ExlList.GetLength();
	l += 3;
	buf = (BYTE*)::calloc(l+4096, sizeof(BYTE));
CMemFile mFile(buf,l+4096);
	CArchive arch(&mFile,CArchive::store);
	arch.m_bForceFlat = FALSE;
	Serialize(arch);
	arch.Close();

	if(RegSetValueEx(hModelKey, LPCTSTR(*sSubKey), 0, REG_BINARY, mFile.Detach(), l) == ERROR_SUCCESS) 
		ret=TRUE;
	mFile.Close();
	free(buf);

	return ret;

}


*/
