// embeddedgps.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "afx.h"
#include "embeddedgps.h"
#include "GpsSetup.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CgpsApp

BEGIN_MESSAGE_MAP(CgpsApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, &CgpsApp::OnAppAbout)
END_MESSAGE_MAP()



// CgpsApp construction
CgpsApp::CgpsApp()
	: CWinApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CgpsApp object
CgpsApp theApp;

// CgpsApp initialization

BOOL CgpsApp::InitInstance()
{
    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the Windows Mobile specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("E de Smidt productions"));

	m_iBaudrate = GetProfileInt(_T("Settings"),REGVALUE_BAUD,9600);
	m_sComName = GetProfileString(_T("Settings"),REGVALUE_COMPORT, _T("COM4:"));

	m_iViewType = GetProfileInt(_T("Settings"),REGVALUE_VIEW,1);
	m_iKmlAlt = GetProfileInt(_T("Settings"),REGVALUE_KML_ALT,0);
	m_iKmh = GetProfileInt(_T("Settings"),REGVALUE_KMH,0);
	m_iutc = GetProfileInt(_T("Settings"),REGVALUE_UTC,1);
	m_iMaxDil = GetProfileInt(_T("Settings"),REGVALUE_MAXDIL,50);
	m_fMaxDil = (double)m_iMaxDil/10.0;
/*	CString sRegKey;			// Open registry key
//	sRegKey = REG_SUBKEY;
//	sRegKey += REG_COMPANYNAME;
	sRegKey = REG_PRODUCTNAME;
	sRegKey += REG_PRODUCTVERSION;
	sRegKey += REG_SETTINGS;

	m_pRegKey = new CRegistry(REG_MAINKEY, sRegKey.GetBuffer(sRegKey.GetLength()));
	if(m_pRegKey->m_hRegistryKey==NULL)
		return FALSE;

	m_iBaudrate = m_pRegKey->GetInt(REGVALUE_BAUD,9600);
	m_pRegKey->GetString(&m_sComName, REGVALUE_COMPORT, _T("COM4:"));
*/
	m_fntMediumFont.CreateFont(26,0,0,0,600,0,0,0,0,OUT_DEFAULT_PRECIS,		// 28
		CLIP_CHARACTER_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,_T("MS Sans Serif"));
	m_fntLargeFont.CreateFont(30,0,0,0,600,0,0,0,0,OUT_DEFAULT_PRECIS,		// 28
		CLIP_CHARACTER_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,_T("MS Sans Serif"));
	m_fntExtraLargeFont.CreateFont(72,0,0,0,600,0,0,0,0,OUT_DEFAULT_PRECIS,
		CLIP_CHARACTER_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,_T("MS Sans Serif"));

	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object
	CMainFrame* pFrame = new CMainFrame;
	if (!pFrame)
		return FALSE;
	m_pMainWnd = pFrame;

	// create maplist. don't load bmp. just determine position of files
	m_lstMaps.RemoveAll();
	WIN32_FIND_DATA fd;
	HANDLE h = FindFirstFile(_T("\\Storage card\\GPS\\*.bmp"),&fd);
	if(h!=INVALID_HANDLE_VALUE) 
	{	do
		{	if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				CGpsMap *map = new CGpsMap;
				map->m_sFilename = _T("\\Storage card\\GPS\\");
				map->m_sFilename += fd.cFileName;//finder.GetFileName();
				if(map->GetFilenamePosition())
					m_lstMaps.AddTail(map);
				else
					delete map;
			}
		} while(FindNextFile(h,&fd)!=0);
	}

	CGpsSetup dlg;
	while(!m_GpsData.Connect(m_sComName,m_iBaudrate))
	{
		AfxMessageBox(_T("GPS not found!\n Please select correct port and baudrate."),MB_OK,NULL);
		if(dlg.DoModal()==IDCANCEL)
			return FALSE;

	}


	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);// | WS_NOTIFY

	m_pMainWnd->SetForegroundWindow();

	m_lstPoints.RemoveAll();


	// The one and only window has been initialized, so show and update it
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();
	return TRUE;
}

int CgpsApp::ExitInstance() 
{

	CMainFrame* pFrame = (CMainFrame*)m_pMainWnd;
	if(pFrame)
		if(pFrame->m_hLcd)
			CloseHandle(pFrame->m_hLcd);
	theApp.m_GpsData.EndLog();

	
	return CWinApp::ExitInstance();
}

// CgpsApp message handlers


// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
#ifdef _DEVICE_RESOLUTION_AWARE
	afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
#endif
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	return TRUE;	// return TRUE unless you set the focus to a control
			// EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
#ifdef _DEVICE_RESOLUTION_AWARE
	ON_WM_SIZE()
#endif
END_MESSAGE_MAP()

#ifdef _DEVICE_RESOLUTION_AWARE
void CAboutDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
    	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? MAKEINTRESOURCE(IDD_ABOUTBOX_WIDE) : MAKEINTRESOURCE(IDD_ABOUTBOX));
	}
}
#endif

// App command to run the dialog
void CgpsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

int CgpsApp::SaveKml(CString *filename)
{
	CString str;
	HANDLE hf = CreateFile( filename->GetBuffer(filename->GetLength()), //_T("LogFile.txt"),
	    GENERIC_READ | GENERIC_WRITE,
	    0,    // comm devices must be opened w/exclusive-access 
	    NULL, // no security attributes 
	    CREATE_ALWAYS, //OPEN_EXISTING, // comm devices must use OPEN_EXISTING 
	    FILE_ATTRIBUTE_NORMAL,    // not overlapped I/O 
		NULL  // hTemplate must be NULL for comm devices 
		);
	if (hf == INVALID_HANDLE_VALUE) 
	{
		hf=NULL;
		str = _T("Error opening:");
		str += *filename;
		AfxMessageBox(str,MB_OK|MB_SETFOREGROUND);
		return 0;
	}
	CFile file(hf);//(HFILE)
/*	if(!file.Open(fdlg.m_ofn.lpstrFile, CFile::modeCreate || CFile::modeWrite), NULL) 
*/
	POSITION pos;
	CGpsPoint *pnt;

//	if(filename.Find(_T(".kml"),0)>0)
//	{
		CString s;
		s = "<?xml version=\x22\x31.0\x22 encoding=\x22UTF-8\x22?><kml xmlns=\x22http://earth.google.com/kml/2.1\x22>\n";
		s += "<Document>\n<name>";
		s+=*filename;
		s+="</name>\n";
		((CMainFrame*)m_pMainWnd)->WriteString( &s,hf); 
		s = "<description>GpsTrack collected with PocketGps on mobile. </description>\n";
		s += "<Style id=\x22yellowLineGreenPoly\x22>";
		s += "<LineStyle><color>7f00ffff</color><width>4</width></LineStyle>";
		s += "<PolyStyle><color>7f00ff00</color></PolyStyle></Style>\n";
		s += "<Style id=\x22yellowLineBluePoly\x22>";
		s += "<LineStyle><color>7f00ffff</color><width>4</width></LineStyle>";
		s += "<PolyStyle><color>7f0000ff</color></PolyStyle></Style>\n";
		((CMainFrame*)m_pMainWnd)->WriteString( &s,hf); 

		// start track
		UINT lasttrack=1;
		s.Format(_T("<Placemark><name>Track%d</name><description> </description>"),lasttrack);

		if(theApp.m_iKmlAlt)
			s += "<styleUrl>#yellowLineGreenPoly</styleUrl>\n";
		else
			s += "<styleUrl>#yellowLineBluePoly</styleUrl>\n";

		s += "<LineString><extrude>1</extrude><tessellate>1</tessellate><altitudeMode>absolute</altitudeMode>\n";
		s += "<coordinates>\n";
		((CMainFrame*)m_pMainWnd)->WriteString( &s,hf); 

		UCHAR lasthour;
		pos = theApp.m_lstPoints.GetHeadPosition();
		pnt = theApp.m_lstPoints.GetAt(pos);
		lasthour=pnt->hour;
		while(pos!=NULL)
		{
			pnt = theApp.m_lstPoints.GetNext(pos);
			//	s.Format(_T("%f,%f,%f\n"), pnt->m_fLong, pnt->m_fLat, pnt->m_fAltitude);

			if(theApp.m_iKmlAlt)
				s.Format(_T("%f,%f,%f\n"), pnt->m_fLong, pnt->m_fLat, pnt->m_fSpeed*KNTS2KMH*10.0);
			else
				s.Format(_T("%f,%f,%f\n"), pnt->m_fLong, pnt->m_fLat, pnt->m_fAltitude);
			((CMainFrame*)m_pMainWnd)->WriteString( &s,hf);
			if(pnt->hour!=lasthour)		// split long tracks!  (very long tracks stay on the ground!)
			{
				lasthour = pnt->hour;
				lasttrack++;
				s = "</coordinates></LineString></Placemark>";
				((CMainFrame*)m_pMainWnd)->WriteString(&s,hf); 
				s.Format(_T("<Placemark><name>Track%d"),lasttrack);
				//s = "<Placemark><name>Track"+lasttrack;
				s += "</name><description> </description>"; //<styleUrl>#yellowLineGreenPoly</styleUrl>\n";
				if(theApp.m_iKmlAlt)
					s += "<styleUrl>#yellowLineGreenPoly</styleUrl>\n";
				else
					s += "<styleUrl>#yellowLineBluePoly</styleUrl>\n";

				s += "<LineString><extrude>1</extrude><tessellate>1</tessellate><altitudeMode>absolute</altitudeMode>\n";
				s += "<coordinates>\n";
				((CMainFrame*)m_pMainWnd)->WriteString(&s,hf); 
			}
		}
		s = "</coordinates></LineString></Placemark>";
		((CMainFrame*)m_pMainWnd)->WriteString(&s,hf); 
		 
	//	Log placemarks and time marks
		pos = theApp.m_lstPoints.GetHeadPosition();
		lasthour=25;
		CString desc;
		while(pos!=NULL)
		{
			pnt = theApp.m_lstPoints.GetNext(pos);
			if(pnt->m_strComment.GetLength() || pnt->hour!=lasthour)
			{
				if(pnt->hour!=lasthour) lasthour = pnt->hour;
				s.Format(_T("<Placemark><name>%s %d:%02d</name>\n"),
					pnt->m_strComment.GetBuffer(256),pnt->hour,pnt->min, desc);
				desc.Format(_T("<description>%d:%02d %s  Speed:%f knots = %f kmh</description>\n"),pnt->hour,pnt->min,pnt->m_strComment.GetBuffer(256),
					pnt->m_fSpeed,pnt->m_fSpeed*KNTS2KMH); 
				s+=desc;
				((CMainFrame*)m_pMainWnd)->WriteString(&s,hf); 
				s.Format(_T("<LookAt><longitude>%f</longitude><latitude>%f</latitude><altitude>%f</altitude>\n"),
				 pnt->m_fLong,pnt->m_fLat,pnt->m_fAltitude );
				s+=_T("<range>1000.00</range><tilt>66.66</tilt>\n");
				s+=_T("<heading>5.164</heading></LookAt><styleUrl>#msn_ylw-pushpin_copy1</styleUrl>\n");
				((CMainFrame*)m_pMainWnd)->WriteString(&s,hf); 
				s.Format(_T("<Point><coordinates>%f,%f,0</coordinates></Point></Placemark>"),pnt->m_fLong, pnt->m_fLat);
				((CMainFrame*)m_pMainWnd)->WriteString(&s,hf); 
			}
		}
		s = _T("</Document></kml>\n");
		((CMainFrame*)m_pMainWnd)->WriteString(&s,hf);  
	file.Close();
//	m_bChanged = FALSE;

	return 1;
}

CGpsMap * CgpsApp::FindMap(void)
{
	CGpsMap *map,*smalmap;

	smalmap=NULL;
	if( (m_GpsData.FillFlags & (GFF_LATITUDE|GFF_LONGITUDE)) == (GFF_LATITUDE|GFF_LONGITUDE) ) // valid data?
	{

		// check maplist with current position.
		// load smallest file

		POSITION pos = theApp.m_lstMaps.GetHeadPosition();
		double x,y;
		x=m_GpsData.Longitude;
		y=m_GpsData.Latitude;
		while(pos)
		{
			map = m_lstMaps.GetNext(pos);
			if(x>map->m_dLong1 && x<map->m_dLong2 && y>map->m_dLat1 && y<map->m_dLat2 &&
				(smalmap==NULL ||	(map->m_dLong2-map->m_dLong1) < (smalmap->m_dLong2-smalmap->m_dLong1)) )
			{
				smalmap = map;	// track smallest map
			}
		}
	}
	return smalmap;
}
