// embeddedgps.h : main header file for the embeddedgps application
//
#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#include "resourceppc.h"


#include "Registry.h"
#include "GpsPoint.h"		// one GPS point data
#include "GpsFrame.h"		// GPS data frame
#include "PocketGpsDlg.h"	// GPS data dialog
#include "GpsMap.h"	// maps

#define KNTS2KMH			1.8152

//#define Knots2Kmh(knts) (knts*1.8152)

#define REG_MAINKEY			HKEY_LOCAL_MACHINE
#define REG_SUBKEY			_T("Software\\")
#define REG_COMPANYNAME		_T("E de Smidt productions\\")
#define REG_PRODUCTNAME		_T("GpsTrack\\")
#define REG_PRODUCTVERSION	_T("V1\\")
#define REG_SETTINGS			_T("Settings\\")
#define REGVALUE_COMPORT	_T("Comport")
#define REGVALUE_IP			_T("IP Address")
#define REGVALUE_BAUD		_T("Baudrate")
#define REGVALUE_VIEW		_T("ViewType")
#define REGVALUE_KML_ALT	_T("KMLaltitude")
#define REGVALUE_KMH			_T("Kmh")
#define REGVALUE_UTC			_T("Utc")
#define REGVALUE_MAXDIL			_T("MaxDilution")

#define REGVALUE_MAPDIR		_T("MapsDir")
#define REGVALUE_DATADIR	_T("DataDir")
// CgpsApp:
// See embeddedgps.cpp for the implementation of this class
//

class CgpsApp : public CWinApp
{
public:
	CgpsApp();
	CRegistry	*m_pRegKey;					//!< key to \HKLM\...\Infoview\...
	CString		m_sComName;
	int			m_iBaudrate;
	int			m_iViewType;				// what dialog to show
	int			m_iKmlAlt;				// 1 for kml altitude as speed
	int			m_iKmh;				// kmh io knots
	int			m_iutc;				// utc correction
	int			m_iMaxDil;				// max dilution to store
	CString		m_sMapDir;
	CString		m_sDataDir;

	CFont			m_fntMediumFont;
	CFont			m_fntLargeFont;
	CFont			m_fntExtraLargeFont;
	CGpsFrame	m_GpsData;

	CGpsPointList	m_lstPoints;

	CGpsMapList	m_lstMaps;
	double		m_fMaxDil;	  // double version of m_iMaxDil


// Overrides
public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();

	int SaveKml(CString *filename);
// Implementation
public:
	afx_msg void OnAppAbout();

	DECLARE_MESSAGE_MAP()
public:
	CGpsMap * FindMap(void);
};

extern CgpsApp theApp;
